/************************************************************************/
/* functs.c								*/
/*                                                                      */
/* Discription                                   	 		*/
/*	Sets up look up table array of user callable function modules.	*/
/*	This is the file to change (along with menus.ini) when		*/
/*	installing new user callable functions.				*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

#define FUNCTS
#include "../charaui/src/charaui.h"
#include "astromod_ui.h"

/*
 * Definition of user callable function index array.
 * Note that this array starts and ends with NULLs. This is so a
 * index of 0 gives nothing and also to help find the end of the array
 * The strings preceeding the function names are the command strings
 * that will be recognised by the command line and the menuing system.
 * All access to these functions are via this table.
 */

int test_create_astromod_data_file_name(int argc, char **argv);

struct {                       
                char    *name;
                int     (*function)(int argc, char **argv);
        } functions[] = 

	{	{NULL,		NULL},
#include "../charaui/src/std_ui_functs.h"
#include "std_astro_functs.h"
		{"file",	test_create_astromod_data_file_name},
		{NULL,		NULL}	};
