/************************************************************************/
/* std_astro_functs.h							*/
/*                                                                      */
/* List of standard functions to be included in any functs.c file.  	*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

#ifndef __STD_ASTRO_FUNCTS__
#define __STD_ASTRO_FUNCTS__
		{"system",	show_astromod_system},
		{"sys",		show_astromod_system},
		{"scopes", 	show_astromod_scopes},
		{"star", 	show_astromod_star},
		{"nostar",	set_no_star},
		{"autocoll",	set_autocoll},
		{"internal",	set_internal},
		{"zenith",	set_zenith},
		{"clrstar",	set_no_star},
		{"chara",	set_chara_star},
		{"hd",		set_hd_star},
		{"refi",	select_reference_cart},
		{"sref", 	select_reference_cart},
		{"useastlib",	set_use_astromod_lib},
		{"sal",		set_use_astromod_lib},
#endif
