/************************************************************************/
/* functs.c								*/
/*                                                                      */
/* Discription                                   	 		*/
/*	Sets up look up table array of user callable function modules.	*/
/*	This is the file to change (along with menus.ini) when		*/
/*	installing new user callable functions.				*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

#define FUNCTS
#include "charaui.h"

int	example(int argc, char **argv);

/*
 * Definition of user callable function index array.
 * Note that this array starts and ends with NULLs. This is so a
 * index of 0 gives nothing and also to help find the end of the array
 * The strings preceeding the function names are the command strings
 * that will be recognised by the command line and the menuing system.
 * All access to these functions are via this table.
 */


int call_open_baytech_rpc_port(int argc, char **argv);
int call_reopen_baytech_rpc_port(int argc, char **argv);
int call_close_baytech_rpc_port(int argc, char **argv);
int call_baytech_rpc_on(int argc, char **argv);
int call_baytech_rpc_off(int argc, char **argv);
int call_baytech_rpc_all_on(int argc, char **argv);
int call_baytech_rpc_all_off(int argc, char **argv);
int call_open_baytech_m4_port(int argc, char **argv);
int call_close_baytech_m4_port(int argc, char **argv);
int call_baytech_m4_relay_status(int argc, char **argv);
int call_baytech_m4_relay_energize(int argc, char **argv);
int call_baytech_m4_relay_de_energize(int argc, char **argv);
int call_baytech_m4_set_dac(int argc, char **argv);
int call_baytech_m4_dac_array(int argc, char **argv);
int call_baytech_m4_adc_status(int argc, char **argv);

struct {                       
                char    *name;
                int     (*function)(int argc, char **argv);
        } functions[] = 

	{	{NULL,		NULL},
#include <std_ui_functs.h>

		/* Local functions */

#include 	"std_rpc_functs.h"
#include 	"std_m4_functs.h"

		{NULL,		NULL}	};
