/************************************************************************/
/* uiclient_functs.c							*/
/*                                                                      */
/* Discription                                   	 		*/
/*	Sets up look up table array of user callable function modules.	*/
/*	This is the file to change (along with menus.ini) when		*/
/*	installing new user callable functions.				*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Wed Oct 10 03:42:20 PDT 2001 */
/************************************************************************/

#define FUNCTS
#include <charaui.h>
#undef FUNCTS
#include "local_uiclient.h"

struct {                       
                char    *name;
                int     (*function)(int argc, char **argv);
        } functions[] = 

	{	
		/* Standard Function Set */

		{NULL,		NULL},
#include <std_ui_functs.h>

		/* Local Function Set */

                {"osn",		call_open_server_socket_by_name},
                {"oss",		call_open_server_socket},
                {"css",		call_close_server_socket},
		{"noop",	call_send_noop},
		{"sping",	call_send_ping},
		{"smess",	call_send_message_message},
		{"anoop",	call_send_all_noop},
		{"asping",	call_send_all_ping},

		{NULL,		NULL}	};
