/************************************************************************/
/* test_airy.c 								*/
/*									*/
/* Test programme for simple X library.  				*/
/* Part of the simpleX library.						*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar						*/
/* Date   : August 1994   						*/
/************************************************************************/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "../nrc/nrc.h"
#include "nsimpleX.h"

int main(int argc, char **argv)
{
	Window  theWindow;
	int     i;
	float **values;
	int     npix;
	char    filter[81];

	if (argc < 3)
	{
		fprintf(stderr,"usage: %s npix filter <display>\n",
			argv[0]);
		exit(-1);
	}

	sscanf(argv[1],"%d",&npix);
	sscanf(argv[2],"%s",filter);

	if (argc < 4)
		i = initX(NULL);
	else
		i = initX(argv[3]);

	if (i<=0)
	{
		fprintf(stderr,"Failed to open display.\n");
		exit(-1);
	}
	infoX();
	printf("Allocated %i colors.\n",i);

	theWindow = openWindow("AIRY FUNCTION",100,100,npix,npix);

	/* Build a test image */

	values = matrix(1,(int)npix,1,(int)npix);

	values = build_airy(npix,npix,47.0,filter,2.54,0.34);

	XSync(theDisplay,TRUE);

	display_picture(theWindow,values,npix,1,LOG);

	sleep(5);

	free_matrix(values,1,(long)npix,1,(long)npix);

	XDestroyWindow(theDisplay,theWindow);

	quitX();

	exit(0);
}
