/************************************************************************/
/* picom_functs.c							*/
/*                                                                      */
/* Discription                                   	 		*/
/*	Sets up look up table array of user callable function modules.	*/
/*	This is the file to change (along with menus.ini) when		*/
/*	installing new user callable functions.				*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Stuart Taylor & Theo ten Brummelaar                         */
/* Date   : Fri Aug 11 10:24:13 PDT 2000                                */
/************************************************************************/

#define FUNCTS
#include <charaui.h>
#undef FUNCTS
#include "picom.h"

int test_control_motor(int argc, char **argv);

struct {                       
                char    *name;
                int     (*function)(int argc, char **argv);
        } functions[] = 

	{	
		/* Standard Function Set */

		{NULL,		NULL},
#include <std_ui_functs.h>
		/* Picom Function Set */
#include "std_picom_functs.h"
		/* Local test functions */
		{"mc", test_control_motor},
                {NULL,          NULL}   };

