#!/usr/bin/python2.3
'''Menu pico
Main pico control menu
to add a new pico control, simply update picoData.py as indicated
does not handle yet multiple connections
.'''
import pygtk
pygtk.require('2.0')
import gtk
import picoData
import windowPico
from optparse import OptionParser

def create_menu(depth, length=5):
    if depth < 1:
        return None

    menu = gtk.Menu()
    group= None

    for i in range(length):
        menuitem = gtk.RadioMenuItem(group, 'item %2d - %d' % (depth, i))
        group = menuitem
        menu.add(menuitem)
        menuitem.show()
        if depth > 1:
            submenu = create_menu(depth - 1)
            menuitem.set_submenu(submenu)
    return menu

class MenuDemo(gtk.Window):
    def __init__(self, parent=None):
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title("Pico Motor Menu")

        vbox = gtk.VBox()
        self.add(vbox)
# the next section can be used as an example to add a menu bar to the gui
#         menubar = gtk.MenuBar()
#         vbox.pack_start(menubar, expand=False)
# 
#         menuitem = gtk.MenuItem('test\nline2')
#         menuitem.set_submenu(create_menu(2, 10))
#         menubar.add(menuitem)
# 
#         menuitem = gtk.MenuItem('foo')
#         menuitem.set_submenu(create_menu(2))
#         menubar.add(menuitem)
# 
#         menuitem = gtk.MenuItem('bar')
#         menuitem.set_submenu(create_menu(2))
#         menuitem.set_right_justified(True)
#         menubar.add(menuitem)

        vbox2 = gtk.VBox(spacing=10)
        vbox2.set_border_width(10)
        vbox.pack_start(vbox2)

        combo_box = gtk.combo_box_new_text()
        combo_box.set_wrap_width(1)
	combo_box.append_text('CHOOSE PICO-MOTOR')
	for nm in picoData.windowName:
		combo_box.append_text(nm)
	combo_box.connect('changed', self.changed_cb)
        combo_box.set_active(0)
        vbox2.pack_start(combo_box)

        separator = gtk.HSeparator()
        vbox.pack_start(separator, expand=False)
        
        vbox2 = gtk.VBox(spacing=10)
        vbox2.set_border_width(10)
        vbox.pack_start(vbox2, expand=False)

        button = gtk.Button('CLOSE')
        button.connect('clicked', lambda button, w=self: w.destroy())
        vbox2.pack_start(button)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
       
	self.show_all()
	
    def changed_cb(self, combobox):
        model = combobox.get_model()
        index = combobox.get_active()
        if index:
            print 'This is ', model[index][0], '!'
	    self.windowPico = windowPico.pico(picoName = model[index][0])
	    gtk.main()
	    self.windowPico.__del__()
	return 0


def main():
    parser = OptionParser(usage="""\
Sets the debug mode
Usage: %prog [options]
.
""")
##     parser.add_option('-d', '--debug',
##                       type='string', dest = debug,
##                       help="""Sets the debug mode.""")
    opts, args = parser.parse_args()
    if len(args):
        picoData.dbg = args[0]
        # print int(args[0])
    MenuDemo()
    gtk.main()
    

if __name__ == '__main__':
    main()
