#!/usr/bin/python -i

#This is a hopefully user-friendly control program for optimizing luminos stages for fiber alignment

from setup import *
from mapping import *
#from doLoop import *

d = Detector()
d.set()

g = Graphics()

# get and hold number of stages
print 'Renumbering mounts (few seconds)...'
n = renumber()

#settings for mapping
map_stage = 3
side = 20
spacing = 2
range_i = [170,240]
range_j = [25,125]
show_image = 1
show_surface = 1
show_intensity = 0

def main():
	print 'Program for fiber alignment'
	main_ans = '-1'
	while main_ans != '0':
		print ''
		print 'Main Menu'
		print '1) Luminos control'
		print '2) Mapping'
		print '3) Detector control'
		print '0) Quit (python command line)'
		main_ans = raw_input(':')
		if main_ans == '1':
			luminos_control()
		elif main_ans == '2':
			mapping()
		elif main_ans == '3':
			detector_controls()
		elif main_ans == '0':
			pass
		else:
			print 'Please choose again'
	return

def luminos_control():
	global n
	lum_ans = '-1'
	while lum_ans != '0':
		print ''
		print 'Luminos Control Menu'
		print '1) Get positions'
		print '2) Move absolute (steps)'
		print '3) Move relative (microns)'
		print '4) Home'
		print '5) Renumber'
		print '6) Save positions to file'
		print '7) Recall positions from file'
		print '8) Index positions from file'
		print '9) Index specific stage & axis'
		print '0) Back to main menu'
		lum_ans = raw_input(':')
		if lum_ans == '1':
			get_positions()
		elif lum_ans == '2':
			move_abs()
		elif lum_ans == '3':
			move_rel()
		elif lum_ans == '4':
			home_stages()
		elif lum_ans == '5':
			n = renumber()
		elif lum_ans == '6':
			save_pos()
		elif lum_ans == '7':
			recall_pos()
		elif lum_ans == '8':
			index_pos()
		elif lum_ans == '9':
			set_pos()
		elif lum_ans == '0':
			pass
		else:
			print 'Please choose again'
	return

def get_positions():
	print ''
	for i in range(1,n+1):
		print 'Stage ',i
		print '        X = ', absolute_position(i,2)
		print '        Y = ', absolute_position(i,3)
		print '        Z = ', absolute_position(i,1)

def move_abs():
	global n
	print ''
	print 'Move stage(s) to absolute position in steps'
	stage = raw_input('Stage: (zero for all): ')
	
	if stage == '0':
		position = raw_input('Position (steps): ')
		for i in range(1,n+1):
			for j in range(1,4):
				move_absolute(i,j,long(position))
		return
			
	axis = raw_input('Axis: (zero for all): ')
	
	if axis == '0':
		position = raw_input('Position (steps): ')
		for j in range(1,4):
			move_absolute(int(stage),j,long(position))
		return
	elif axis == 'z' or axis == 'Z':
		axis = '1'
	elif axis == 'x' or axis == 'X':
		axis = '2'
	elif axis == 'y' or axis == 'Y':
		axis = '3'
	else:
		pass
			
	position = raw_input('Position (steps): ')
	move_absolute(int(stage),int(axis),long(position))
		
	return

def move_rel():
	global n
	print ''
	print 'Move stage(s) forward or backward in microns'

	stage = raw_input('Stage: (zero for all): ')
	
	if stage == '0':
		move = raw_input('+- microns: ')
		for i in range(1,n+1):
			move_relative(i,1,long(float(move)*10))
			for j in range(2,4):
				move_relative(i,j,long(float(move)*250))
		return
			
	axis = raw_input('Axis: (zero for all): ')
	
	if axis == '0':
		move = raw_input('+- microns: ')
		move_relative(i,1,long(float(move)*10))
		for j in range(2,4):
			move_relative(int(stage),j,long(float(move)*250))
		return
	elif axis == 'z' or axis == 'Z':
		axis = '1'
	elif axis == 'x' or axis == 'X':
		axis = '2'
	elif axis == 'y' or axis == 'Y':
		axis = '3'
	else:
		pass
			
	move = raw_input('+- microns: ')
	if axis == '1':
		move_relative(int(stage),int(axis),long(float(move)*10))
	elif axis == '2' or axis == '3':
		move_relative(int(stage),int(axis),long(float(move)*250))
	else:
		print 'error: invalid axis'
	return

def home_stages():
	print ''
	print 'Home stage(s)'
	stage = raw_input('Stage: (zero for all): ')
	
	if stage == '0':
		home(0,0)
		return
			
	axis = raw_input('Axis: (zero for all): ')
	
	if axis == '0':
		home(int(stage),0)
		return
	elif axis == 'z' or axis == 'Z':
		axis = '1'
	elif axis == 'x' or axis == 'X':
		axis = '2'
	elif axis == 'y' or axis == 'Y':
		axis = '3'
	else:
		pass
			
	home(int(stage),int(axis))
				
	return
	
def save_pos():
	global n
	print ''
	print 'Save current positions to a file'
	filename = raw_input('Filename: ')
	save_position(filename,n)

def recall_pos():
	global n
	print ''
	print 'Recall current positions from a file'
	filename = raw_input('Filename: ')
	recall_position(filename,n)

def index_pos():
	global n
	print ''
	print 'Index current positions from a file'
	filename = raw_input('Filename: ')
	index_position(filename,n)

def set_pos():
	
	global n
	print ''
	print 'Index stage(s) to position in steps'
	stage = raw_input('Stage: (zero for all): ')
	
	if stage == '0':
		position = raw_input('Position (steps): ')
		for i in range(1,n+1):
			for j in range(1,4):
				set_position(i,j,long(position))
		return
			
	axis = raw_input('Axis: (zero for all): ')
	
	if axis == '0':
		position = raw_input('Position (steps): ')
		for j in range(1,4):
			set_position(int(stage),j,long(position))
		return
	elif axis == 'z' or axis == 'Z':
		axis = '1'
	elif axis == 'x' or axis == 'X':
		axis = '2'
	elif axis == 'y' or axis == 'Y':
		axis = '3'
	else:
		pass
			
	position = raw_input('Position (steps): ')
	set_position(int(stage),int(axis),long(position))
		
	return

def mapping():
	global n
	map_ans = '-1'
	while map_ans != '0':
		print ''
		print 'Mapping Menu'
		print '1) Perform XY map'
		print '2) Change map settings'
		print '3) Move focus'
		print '4) Get intensity'
		print '0) Back to main menu'
		map_ans = raw_input(':')
		if map_ans == '1':
			do_map()
		elif map_ans == '2':
			map_settings()
		elif map_ans == '3':
			move_focus()
		elif map_ans == '4':
			get_intensity()
		elif map_ans == '0':
			pass
		else:
			print 'Please choose again'
	
	return
	
def do_map():
	
	global map_stage,side,spacing,d,range_i,range_j,show_surface,show_intensity
	
	d.do_image_show = 0
	d.do_image_save = 0
	
	print ''
	print 'Z = ',absolute_position(map_stage,1)
	print 'Mapping XY square, ',side,'x',side,' microns, ',spacing,' micron spacing...'
	
	[intensity,x,y,dummy] = xy_square(map_stage,side,spacing,d,range_i,range_j,show_image)
	[x_max,y_max,high] = get_max(intensity,x,y)
	
	print 'Max intensity is ',high,' at X = ',x_max,' and Y = ',y_max
	
	#if show_surface:
	#	xy_surf(intensity,x,y)
	
	x0 = absolute_position(map_stage,2)
	y0 = absolute_position(map_stage,3)
	
	move_absolute(map_stage,2,x_max)
	move_absolute(map_stage,3,y_max)
	
	if d.do_image_show != 0:
		d.do_image_show = 0
		d.Exposure()
		d.do_image_show = 1
	else:
		d.Exposure()
	
	max_pixel = 0
	for i in range(range_i[0],range_i[1]):
		for j in range(range_j[0],range_j[1]):
			if d.img[i][j] > max_pixel:
				max_pixel = d.img[i][j]
				max_i = i
				max_j = j
	
	print 'Max pixel with XY at this location is i = ',max_i,', j = ',max_j,', intensity = ',max_pixel
		
	max_ans = raw_input('Move to maximum (y/n): ')
	if max_ans == 'y' or max_ans == 'Y' or max_ans == '1':
		pass
	else:
		move_absolute(map_stage,2,x0)
		move_absolute(map_stage,3,y0)
		print 'Moved back to start point X = ',absolute_position(map_stage,2),' and Y = ',absolute_position(map_stage,3)
	
	
	
	if show_intensity:
		print intensity
	
	return
	

	
def map_settings():
	global map_stage,side,spacing,range_i,range_j,show_image,show_surface,show_intensity
	
	print ''
	print 'Adjust map settings'	
	print 'Enter nothing to keep value'
	print ''
			
	print 'map range = ',side, ' microns'
	side_change = raw_input('change to:')
	
	print 'map spacing = ',spacing, ' microns'
	spacing_change = raw_input('change to:')
	
	print 'stage for mapping = ',map_stage
	map_stage_change = raw_input('change to:')
		
	range_i_change = [None]*2
	range_j_change = [None]*2
	
	print 'pixel range dat.img[',range_i[0],',',range_i[1],'][]'
	range_i_change[0] = raw_input('change range i, lower limit :')
	range_i_change[1] = raw_input('upper limit :')
		
	print 'pixel range dat.img[][',range_j[0],',',range_j[1],']'
	range_j_change[0] = raw_input('change range j, lower limit :')
	range_j_change[1] = raw_input('upper limit :')
	
	print 'show image during mapping = ',show_image
	show_image_change = raw_input('change to:')
	
	print 'show surface after map = ',show_surface
	show_surface_change = raw_input('change to:')
	
	print 'show intensity array after map = ',show_intensity
	show_intensity_change = raw_input('change to:')
	
	print ''		
	save_changes = ''
	while save_changes == '':
		save_changes = raw_input('save changes made (y/n):')
	
	if save_changes == 'y' or save_changes == 'Y' or save_changes == '1':
		if map_stage_change == '':
			pass
		else:
			map_stage = int(map_stage_change) 
		if side_change == '':
			pass
		else:
			side = float(side_change) 
		if spacing_change == '':
			pass
		else:
			spacing = float(spacing_change) 
		if range_i_change[0] == '':
			pass
		else:
			range_i[0] = int(range_i_change[0])
		
		if range_i_change[1] == '':
			pass
		else:
			range_i[1] = int(range_i_change[1])

		if range_j_change[0] == '':
			pass
		else:
			range_j[0] = int(range_j_change[0])
		if range_j_change[1] == '':
			pass
		else:
			range_j[1] = int(range_j_change[1])
		if show_image_change == '':
			pass
		else:
			show_image = int(show_image_change)
		if show_surface_change == '':
			pass
		else:
			show_surface = int(show_surface_change)
		if show_intensity_change == '':
			pass
		else:
			show_intensity = int(show_intensity_change)
		print 'Changes saved'
	else:
		print 'Changes not saved'
		
	return

def get_intensity():
	d.do_image_show = 0
	d.do_image_save = 0
	d.Exposure()
	max_pixel = 0
	total_intensity = 0
	for i in range(range_i[0],range_i[1]):
		for j in range(range_j[0],range_j[1]):
			total_intensity += d.img[i][j]
			if d.img[i][j] > max_pixel:
				max_pixel = d.img[i][j]
				max_i = i
				max_j = j
	
	print 'Total intensity is ',total_intensity
	print 'Max pixel is i = ',max_i,', j = ',max_j,', intensity = ',max_pixel
	
	return
	
	
def move_focus():
	global map_stage
	print 'Z = ',absolute_position(map_stage,1)
	move = raw_input('Move Z +- microns:')
	if move == '':
		'No change in focus'
	else:	
		move_relative(map_stage,1,long(float(move)*10))
		print 'now Z = ',absolute_position(map_stage,1)
	
	return

def detector_controls():
	global d,range_i,range_j,g
	det_ans = '-1'
	while det_ans != '0':
		print ''
		print 'Detector control'
		print '1) View detector (takes exposure)'
		print '2) Save image (takes exposure)'
		print '3) View cross section (takes exposure)'
		#print '4) Run cross section "doloop"'
		print '0) Back to main menu'
		det_ans = raw_input(':')
		if det_ans == '1':
			d.do_image_show = 1
			d.do_image_save = 0
			d.Exposure()
		elif det_ans == '2':
			d.do_image_save = 1
			d.do_image_show = 1
			d.Exposure()
			d.do_image_save = 0
		elif det_ans == '3':
			#print 'Take Cross section across highest pixel in range specified by map settings.'
			row = raw_input('Take cross section across row: ')
			d.do_image_save = 0
			d.do_image_show = 1
			d.Exposure()
			max_pixel = 0
			#for i in range(range_i[0],range_i[1]):
			#	for j in range(range_j[0],range_j[1]):
			#		if d.img[i][j] > max_pixel:
			#			max_pixel = d.img[i][j]
			#			max_i = i
			#			max_j = j
			#print 'Plotting acros j = ',max_j
			g.plot(d.img[:,int(row)])
		#elif det_ans == '4':
			#loops = raw_input('Number of loops: ')
			#row = raw_input('Take cross section across row: ')
			#doLoop(int(loops),0,int(row),d,g)
		elif det_ans == '0':
			pass
		else:
			print 'Please choose again'
	
	return

main()
