#!/usr/bin/python

from matplotlib.numerix import arange, sin, pi

import matplotlib
matplotlib.use('GTKAgg')
from pylab import *

# switch comments for gtk over gtkagg
#from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas
from matplotlib.backends.backend_gtkagg import FigureCanvasGTKAgg as FigureCanvas

#currently backend_gtk DOESN'T have NavigationToolbar functionallity, need to get this fixed
# or NavigationToolbar for classic
#from matplotlib.backends.backend_gtk import NavigationToolbar2GTKAgg as NavigationToolbar

from matplotlib.axes import Subplot
from matplotlib.figure import Figure

from matplotlib.mlab import meshgrid
from matplotlib.mlab import bivariate_normal
from matplotlib import rcParams

import pygtk
## pygtk.require('2.0')
import gtk

from gauss_mpfit import gauss_fit
from luminos import *
import zabar as z
## from mapping import *
#from setup import *
## from doLoop import *

class fiber:
		
	#move luminos function
 	def move(self,widget,direction):
 		if direction == 'UP': 
 			move_relative(self.stage,3,long(self.xy_spin_button.get_value()*250))
		elif direction == 'DOWN':
 			move_relative(self.stage,3,long(-1*self.xy_spin_button.get_value()*250))
 		elif direction == 'RIGHT':
 			move_relative(self.stage,2,long(self.xy_spin_button.get_value()*250))
		elif direction == 'LEFT':
 			move_relative(self.stage,2,long(-1*self.xy_spin_button.get_value()*250))
 		elif direction == 'IN':
			move_relative(self.stage,1,long(self.z_spin_button.get_value()*10))
		elif direction == 'OUT':
			move_relative(self.stage,1,long(-1*self.z_spin_button.get_value()*10))
		else:
 			print 'function move received direction = ',direction
		
		if (self.auto_det_section):
			self.view_detector_section(0)

		if (self.detector_configured):
			print 'intensity: ', get_intensity(self.dat,self.range_i,self.range_j)
			
		#refresh positions
		self.refresh_positions(0)
			
	#function to automatically display detector section after each move (toggle switch)
	def auto_det_section_toggled(self,widget):
		self.auto_det_section = self.auto_det_section_check.get_active()

	#function for changing active luminos mount, menus in both the luminos and mapping tabs are changed 	
	def luminos_menu_changed(self,combo_box):
		self.stage = combo_box.get_active() + 1
		self.luminos_combo_box.set_active(self.stage - 1)
		self.mapping_combo_box.set_active(self.stage - 1)
		
		#insert function to refresh positions listed
		self.refresh_positions(0)
			
	#function for returning an arrow button
	def create_arrow_button(self,arrow_type, shadow_type):
		button = gtk.Button();
    		arrow = gtk.Arrow(arrow_type, shadow_type);
    		button.add(arrow)
    		button.show()
    		arrow.show()
    		return button	
	
	#functions for saving current position to a file
	def save_pos(self,widget):
		
		self.save_filew = gtk.FileSelection('Save all positions to file')
		self.save_filew.connect("destroy",lambda w: self.save_filew.destroy())
		self.save_filew.ok_button.connect("clicked",self.file_save_action)
		self.save_filew.cancel_button.connect("clicked",lambda w: self.save_filew.destroy())
		self.save_filew.show()

	#function to actually do the filesaving
	def file_save_action(self,widget):
		save_position(self.save_filew.get_filename(),self.n)
		print "save info to %s" % self.save_filew.get_filename()
		self.save_filew.destroy()

	#functions for recalling position from a file
	def recall_pos(self,widget):
		
		self.recall_filew = gtk.FileSelection('Recall all positions from file')
		self.recall_filew.connect("destroy",lambda w: self.recall_filew.destroy())
		self.recall_filew.ok_button.connect("clicked",self.file_recall_action)
		self.recall_filew.cancel_button.connect("clicked",lambda w: self.recall_filew.destroy())
		self.recall_filew.show()

	#function that actually recalls the file
	def file_recall_action(self,widget):
		recall_position(self.recall_filew.get_filename(),self.n)
		print "recalled info from %s" % self.recall_filew.get_filename()
		self.recall_filew.destroy()		

		#insert function to refresh position
		self.refresh_positions(0)

	#move to what's entered in the position text boxes
	def move_to_enterred(self,widget):
		print 'moving mount ',self.stage, ' to X:, ',long(self.x_position_entry.get_text()),' Y:,',long(self.y_position_entry.get_text()),' Z:,',long(self.z_position_entry.get_text())
		move_absolute(self.stage,2,long(self.x_position_entry.get_text()))
		move_absolute(self.stage,3,long(self.y_position_entry.get_text()))
		move_absolute(self.stage,1,long(self.z_position_entry.get_text()))
		
		if (self.auto_det_section):
			self.view_detector_section(0)
		
		self.refresh_positions(0)


	#reload positions		
	def refresh_positions(self,widget):
		self.xposition = self.xposition +1
		self.yposition = self.yposition +1
		self.zposition = self.zposition +1

		#text in the Luminos Tab
		self.x_position_entry.set_text(str(absolute_position(self.stage,2)))
		self.y_position_entry.set_text(str(absolute_position(self.stage,3)))
		self.z_position_entry.set_text(str(absolute_position(self.stage,1)))
		
		#text in the mapping tab (z position in microns)
		self.z_position_microns.set_text(str(absolute_position(self.stage,1) / 10.))

	def index_to_enterred(self,widget):
		
		set_position(self.stage,1,long(self.z_position_entry.get_text()))
		set_position(self.stage,2,long(self.x_position_entry.get_text()))
		set_position(self.stage,3,long(self.y_position_entry.get_text()))
		print 'indexing mount ',self.stage, ' to X:, ',self.x_position_entry.get_text(),' Y:,',self.y_position_entry.get_text(),' Z:,',self.z_position_entry.get_text()
		
	def renumber_mount(self,widget):
		
		for i in range(self.n):
			self.luminos_combo_box.remove_text(0)
			self.mapping_combo_box.remove_text(0)

		print 'renumbering mounts '
		
		self.n = renumber()	
		
		for i in range(self.n):
			self.luminos_combo_box.append_text('Luminos Stage # %d' % (i+1))
			self.mapping_combo_box.append_text('Luminos Stage # %d' % (i+1))
		
		self.luminos_combo_box.set_active(0)

	def restart_mounts(self,widget):
		restart()
		self.renumber_mount(0)		

	def home_mount(self,widget,all=False):
		if (all):
			print 'homing all mounts'
			home(0,0)
		else:
			print 'homing mount ',self.stage
			home(self.stage,0)
		
		self.refresh_positions(0)
			
	def map_it_up(self,widget,add=False):
		if (self.detector_configured):
			print 'doing map with mount ',self.stage,' with range, ',self.xy_range_spin_button.get_value(), ' and spacing ',self.xy_step_spin_button.get_value(), ' in microns'
		else:
			print 'please configure detector'
			return

		if (add):
			if self.last_map_params[0] == 0:
				print 'Please do a normal map first'
				return
			else:
				print 'params: ',self.last_map_params
				move_absolute(self.last_map_params[0],2,self.last_map_params[1])
				move_absolute(self.last_map_params[0],3,self.last_map_params[2])
				new_intensity,self.x,self.y,self.map_error = xy_square(self.last_map_params[0],self.last_map_params[3],self.last_map_params[4], self.dat, self.range_i, self.range_j, self.display_as_mapped)
				self.intensity = array(self.intensity) + array(new_intensity)

		else:
			self.last_map_params = [self.stage,long(self.x_position_entry.get_text()),long(self.y_position_entry.get_text()),self.xy_range_spin_button.get_value(),self.xy_step_spin_button.get_value()]
			self.intensity,self.x,self.y,self.map_error = xy_square(self.stage,self.xy_range_spin_button.get_value(), self.xy_step_spin_button.get_value(), self.dat, self.range_i, self.range_j, self.display_as_mapped)
			
		if (self.map_error):
			return

		self.intensity_fit, self.fit_params = gauss_fit(self.intensity,self.x,self.y)
		
		self.last_max_x,self.last_max_y,self.last_max_intensity = get_max(self.intensity,self.x,self.y)
		self.last_max_z = absolute_position(self.stage,1)
		
		self.last_max_x_text.set_text(str(self.last_max_x))
		self.last_max_y_text.set_text(str(self.last_max_y))		
		self.last_max_z_text.set_text(str(self.last_max_z))	
		self.last_max_intensity_text.set_text(str(self.last_max_intensity))	
	
		self.last_gauss_x = long(self.fit_params[4])
		self.last_gauss_y = long(self.fit_params[5])
		self.last_gauss_sigma_x = self.fit_params[2]
		self.last_gauss_sigma_y = self.fit_params[3]
		
		self.last_gauss_x_text.set_text(str(self.last_gauss_x))
		self.last_gauss_y_text.set_text(str(self.last_gauss_y))
		self.last_gauss_sigma_x_text.set_text(str(self.last_gauss_sigma_x*2.354/250.))
		self.last_gauss_sigma_y_text.set_text(str(self.last_gauss_sigma_y*2.354/250.))

		if (self.move_to_max):
			move_absolute(self.stage,2,self.last_max_x)
			move_absolute(self.stage,3,self.last_max_y)
			print 'move to max after mapping'
			self.refresh_positions(0)
		if (self.move_to_gauss_peak):
			move_absolute(self.stage,2,self.last_gauss_x)
			move_absolute(self.stage,3,self.last_gauss_y)
			print 'move to gauss peak after mapping'
			self.refresh_positions(0)
		if (self.show_surface_after):
			print 'plot surface'
			self.show_last_surface(0)
		if (self.show_image_after):
			print 'plot image'
			self.plot_image()

	def z_map_spin_button_changed(self,widget):
		self.z_spin_button.set_value(self.z_map_spin_button.get_value())

	def z_spin_button_changed(self,widget):
		self.z_map_spin_button.set_value(self.z_spin_button.get_value())

	def move_to_max_toggled(self,widget):
		self.move_to_max = self.move_to_max_check.get_active()
		print 'self.move_to_max = ',self.move_to_max
		if (self.move_to_max):
			self.move_to_gauss_peak_check.set_active(False)	
	
	def move_to_gauss_peak_toggled(self,widget):
		self.move_to_gauss_peak = self.move_to_gauss_peak_check.get_active()
		print 'self.move_to_gauss_peak = ',self.move_to_gauss_peak
		if (self.move_to_gauss_peak):
			self.move_to_max_check.set_active(False)

	def display_as_mapped_toggled(self,widget):
		self.display_as_mapped = self.display_as_mapped_check.get_active()
		#print 'self.display_as_mapped = ',self.display_as_mapped

	def show_surface_after_toggled(self,widget):
		self.show_surface_after = self.show_surface_after_check.get_active()
		#print 'self.show_surface_after = ',self.show_surface_after

	def show_image_after_toggled(self,widget):
		self.show_image_after = self.show_image_after_check.get_active()
		#print 'self.show_image_after = ',self.show_image_after


	def move_to_last_max(self,widget):
		if self.last_map_params[0] == 0:
			print 'please do a map first'
		else:
			move_absolute(self.stage,2,long(self.last_max_x))
			move_absolute(self.stage,3,long(self.last_max_y))
			move_absolute(self.stage,1,long(self.last_max_z))
			self.refresh_positions(0)

	def get_current_intensity(self,widget):
		if (self.detector_configured):
			self.current_intensity = get_intensity(self.dat,self.range_i,self.range_j)
			self.get_intensity_text.set_text(str(self.current_intensity))
		else:
			print 'please configure detector'

	def show_last_surface(self,widget):
		
		if (self.map_error):
			print 'please take a map first'
			return

		print 'scipy not yet intalled!'
		#xy_surf(self.intensity,self.x,self.y)
		

	def show_last_image(self,widget):
		#print 'plot self.intensity vs self.x and self.y using imshow(), from pylab'
		self.plot_image(gauss=False)

	def move_to_last_gauss(self,widget):
		#print 'move to x: ',long(self.last_gauss_x_text.get_text()),' and y: ',long(self.last_gauss_y_text.get_text())
		if self.last_map_params[0] == 0:
			print 'please do a map first'
		else:
			move_absolute(self.stage,2,long(self.last_gauss_x))
			move_absolute(self.stage,3,long(self.last_gauss_y))
			move_absolute(self.stage,1,long(self.last_max_z))
			self.refresh_positions(0)

	def show_last_gauss(self,widget):
		#print 'plot self.intensity vs self.x and self.y as image with imshow'
		#print 'then overplot a contour of self.intensity_fit and self.x, self.y'
		if self.last_map_params[0] == 0:
			print 'please do a map first'
		else:
			self.plot_image()


	def img_changed(self,widget,letter):
		if letter == 'a':
			self.range_i[0]=self.a_spin_button.get_value_as_int()
		elif letter == 'b':
			self.range_i[1]=self.b_spin_button.get_value_as_int()
		elif letter == 'c':
			self.range_j[0]=self.c_spin_button.get_value_as_int()
		elif letter == 'd':
			self.range_j[1]=self.d_spin_button.get_value_as_int()

	def view_detector_section(self,widget):
		if (self.detector_configured):
			#print 'taking exposure and plotting just across img[',self.range_i[0],':',self.range_i[1],'][',self.range_j[0],':',self.range_j[1],']'
			#self.dat.Exposure()
		        #JDM makes everything a loop...	
			for i in range(self.do_loop_spin_button.get_value()):
				self.plot_exposure(section=True)
		else:
			print 'please configure detector'
			
	def view_whole_detector(self,widget):
		if (self.detector_configured):
			#print 'taking exposure and plotting all of img, img[:][:]'
			for i in range(self.do_loop_spin_button.get_value()):
				self.plot_exposure(section=False)
		else:
			print 'please configure detector'

	def save_image(self,widget):
		if (self.detector_configured):
			print 'set do_save_image to one, take exposure, then set it back to 0'
			self.dat.do_image_save = 1
			self.dat.Exposure()
			self.dat.do_image_save = 0
		else:
			print 'please configure detector'

	def view_cross_section(self,widget):
		if (self.detector_configured):
			for i in range(self.do_loop_spin_button.get_value()):
				self.dat.Exposure()
				self.g.plot(self.dat.img[:,self.e_spin_button.get_value_as_int()])

			#print 'plot only across img[:][',self.e_spin_button.get_value_as_int(),']'
		else:
			print 'please configure detector'

	def run_do_loop(self,widget):
		if (self.detector_configured):
			doLoop(self.do_loop_spin_button.get_value(),0,self.e_spin_button.get_value_as_int(),self.dat,self.g)
			print 'run do_loop across img[:][',self.e_spin_button.get_value_as_int(),'] for ',self.do_loop_spin_button.get_value(),' iterations'
		else:
			print 'please configure detector'

	def change_exp_time(self,widget):
		if (self.detector_configured):
			#print 'change exposure time to', self.exp_time_spin_button.get_value_as_int()
			self.dat.exptime = self.exp_time_spin_button.get_value_as_int()
			self.dat.set_singleExposure()
			#sleep(2)
			print 'exposure time changed'
		else:
			print 'please configure detector'

	def configure_detector(self,widget):
		if self.first_time_configured:
			print 'first configure'
			self.dat = Detector()
			#sleep(1)
			self.first_time_configured = 0
		try:
			self.dat.set()
			self.dat.set_singleExposure()
		
		except IOError, detail:
			print "Retry to set controller ... \n"
			self.dat.set()
			self.dat.set_singleExposure()
		
		#self.dat.exptime = self.exp_time_spin_button.get_value_as_int()
		#self.dat.set_singleExposure()
		#sleep(2)
		self.dat.do_image_show = 0
		self.dat.do_image_save = 0
		self.g = Graphics()
		
		self.detector_configured = 1

	def free_detector(self,widget):
		del(self.dat)
		self.detector_configured = 0

	def plot_image(self,gauss=True):

		if (self.map_error):
			print 'please take a map first'
			return
		
		rcParams['interactive']=True

		#destroy last window
		#self.int_image_window.destroy()
		#del(self.int_image_window)
		#creat a new window to display image
		#self.int_image_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		#self.int_image_window.connect("destroy",self.int_image_window.destroy)
		#self.int_image_window.set_size_request(500, 500)
		#self.int_image_window.set_title("Last Map Image")
		
		#show the window if it isn't up
		#self.int_image_window.show()

		#get rid of last image
		#self.int_canvas.destroy()
		#self.int_fig.clear()

		#self.int_image = self.int_fig.add_subplot(111)
		
		delta = self.x[1]-self.x[0]
		xmin = self.x[0]-delta/2.
		xmax = self.x[-1]+delta/2.
		ymin = self.y[0]-delta/2.
		ymax = self.y[-1]-delta/2.
		self.extent = (xmin,xmax,ymin,ymax)
		
		figure(2)
		clf()		

		imshow(self.intensity,cmap=cm.cool,extent=self.extent,origin='lower',interpolation='nearest')
		if (gauss):
			contour(self.intensity_fit,cmap=cm.bone,extent=self.extent,origin='lower')
			title('Intensity vs Position Image w/ Gauss Contour')
		else:
			title('Intensity vs Position Image')

		if self.first_time_plot:
			xlabel('X Position in Steps')
			ylabel('Y Position in Steps')
			ylabel('Y Position in Steps') #advance the frame
		

		#self.int_canvas = FigureCanvas(self.int_fig)  # a gtk.DrawingArea
		#self.int_canvas.show()
		
		#self.int_toolbar = NavigationToolbar(self.int_canvas, win)
		
		#self.int_image_window.add(self.int_canvas)		

	def plot_exposure(self,section=False):

		self.dat.Exposure()
		#sleep(0.5)		
		#destroy last window
		#self.detector_image_window.destroy()
		#del(self.detector_image_window)
		#creat a new window to display image
		#self.detector_image_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		#self.detector_image_window.connect("destroy",self.detector_image_window.destroy)
		#self.detector_image_window.set_size_request(400, 400)
		#self.detector_image_window.set_title("Exposure")
		
		#show the window if it isn't up
		#self.detector_image_window.show()

		#get rid of last image
		#self.int_canvas.destroy()
		#self.detector_fig.clear()
		
		rcParams['interactive']=True
		
		figure(1)
		#clf()
				
		#self.detector_image = self.detector_fig.add_subplot(111)
		
		#test of exposure plot
					
		if (section):
			self.detector_extent = (self.range_i[0]-0.5,self.range_i[1]+0.5,self.range_j[0]-0.5,self.range_j[1]+0.5)
			#print 'self.detector_extent',self.detector_extent
			self.reduced_exposure = transpose(transpose(self.dat.img[self.range_i[0]:self.range_i[1]+1].copy())[self.range_j[0]:self.range_j[1]+1].copy())
			kludgemedian=median(  median(1.0*self.reduced_exposure))
			tempvar=transpose(1.0*self.reduced_exposure-kludgemedian)
			kludgesum=sum( sum(tempvar))
			tempvar=tempvar/kludgesum
			print 'Median of Section: ', kludgemedian
			print 'flux fraction map: '
			print fix(tempvar*100.0)
			#print 'self.reduced_exposure: ',transpose(1.0*self.reduced_exposure-median(1.0*self.reduced_exposure))
			#self.detector_image.imshow(transpose(self.reduced_exposure),cmap=cm.gray,extent=self.detector_extent,origin='lower')
			imshow(transpose(self.reduced_exposure),interpolation='nearest', cmap=cm.gray,extent=self.detector_extent,origin='lower')
			title('Section Exposure w/ max: %e and min %e' % (self.reduced_exposure.max(),self.reduced_exposure.min()))
		else:
			self.detector_extent = (-0.5,255.5,-0.5,255.5)
			#self.detector_image.imshow(transpose(self.dat.img),cmap=cm.gray,extent=self.detector_extent,origin='lower')
			imshow(transpose(self.dat.img),cmap=cm.gray,extent=self.detector_extent,origin='lower')		
			title('Exposure w/ max: %e and min %e' % (self.dat.img.max(), self.dat.img.min()))
						

		if self.first_time_exposure:
			xlabel('dat.img[x][]')
			ylabel('dat.img[][y]')
			ylabel('dat.img[][y]') # to advance the frame
			self.first_time_exposure = 0

		#self.detector_canvas = FigureCanvas(self.detector_fig)  # a gtk.DrawingArea
		#self.detector_canvas.show()
		
		#self.detector_toolbar = NavigationToolbar(self.detector_canvas, win)
		
		#self.detector_image_window.add(self.detector_canvas)	

		
		
	def __init__(self):

## 		configure()

		self.first_time_configured = 1
		self.first_time_exposure = 1
		self.first_time_plot = 1

		#set defaults
		self.stage = 1
		self.n = renumber()
						
		#test variables: (can be deleted)
		self.xposition = 0
		self.yposition = 0
		self.zposition = 0	
		self.current_intensity = 0
		
		self.first_time = 1

		self.last_map_params = [0]*5
		
		self.x = arange(50000.,55100.,100.)
		self.y = arange(40000.,45100.,100.)
		x_mesh,y_mesh = meshgrid(self.x,self.y)
		
		#test intensity
		base = 10.
		amp = 50.
		sigma = 1000.
		mux = 52500.
		muy = 42500.
		
		self.intensity = base + amp*exp(-0.5*(((x_mesh-mux)**2)/(sigma**2) + ((y_mesh-muy)**2)/(sigma**2)))
		self.intensity_fit = 0
		self.fit_params = 0
		self.map_error = True

		self.i = arange(0,256,1)
		self.j = arange(0,256,1)
		self.j_mesh,self.i_mesh = meshgrid(self.j,self.i)
		#self.dat_img = self.j_mesh + self.i_mesh

		self.dat = 0
		self.g = 0

		self.last_max_x = 0
		self.last_max_y = 0
		self.last_max_z = 0
		self.last_max_intensity = 0
		self.last_gauss_x = 0
		self.last_gauss_y = 0
		self.last_gauss_sigma_x = 0
		self.last_gauss_sigma_y = 0
		
		self.range_i = [0,256]
		self.range_j = [0,256]

		self.detector_configured = 0

		#create window
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		
		#set window size
		#self.window.set_size_request(300, 150)
		
		#give it a name
		self.window.set_title("Fiber Explorer")
		
		#identify the destroy signal
		self.window.connect("destroy", lambda x: gtk.main_quit())

		#show the window
		self.window.show()				
		
		#create a notebook to sit in the main window
		self.notebook = gtk.Notebook()
        	
		#set tabs along the top
		self.notebook.set_tab_pos(gtk.POS_TOP)
        	
		#attach the notebook to the window
		self.window.add(self.notebook)

		#show the notebook
		self.notebook.show()
				
		#create little tables to sit within each notebook page
		self.luminos_table = gtk.Table(8,8,False)
		self.luminos_table.show()
		luminos_label = gtk.Label('Luminos Control')
		self.notebook.append_page(self.luminos_table,luminos_label)
		
		self.mapping_table = gtk.Table(8,8,False)
		self.mapping_table.show()
		mapping_label = gtk.Label('Fiber Mapping')
		self.notebook.append_page(self.mapping_table,mapping_label)

		self.detector_table = gtk.Table(8,8,False)
		self.detector_table.show()
		detector_label = gtk.Label('Detector Control')
		self.notebook.append_page(self.detector_table,detector_label)

		self.zabar_table = gtk.Table(8,8,False)
		self.zabar_table.show()
		self.zabar_label = gtk.Label('Ealing Control')
		self.notebook.append_page(self.zabar_table,self.zabar_label)

		#add a test plot
		#fig = Figure(figsize=(20,20), dpi=100)
		#u = arange(0,10,1)
		#y,x = matplotlib.mlab.meshgrid(u,u)
		#z = matplotlib.mlab.bivariate_normal(x,y,mux=5,muy=5)#,sigmax=20.,sigmay=20.,mux=50.,muy=50.,sigmaxy=50.)
		
		#ax = fig.add_subplot(111)
		#ax.imshow(z,cmap=cm.cool)
		#ax.contour(z,cmap=cm.bone)
		#ax.set_title('hello')
		
		#vbox = gtk.VBox()
		#vbox.show()
				
		#canvas = FigureCanvas(fig)  # a gtk.DrawingArea
		#canvas.show()
		#vbox.pack_start(canvas)

		#toolbar = NavigationToolbar(canvas, win)
		#vbox.pack_start(toolbar, False, False)

		#self.plot_window=gtk.Window(gtk.WINDOW_TOPLEVEL)
		#self.plot_window.set_size_request(350,350)
		#self.plot_window.connect("destroy",self.plot_window.destroy)
		#self.plot_window.show()
		#self.plot_window.add(vbox)
		
		
		##############  LUMINOS TAB   ###############
		
		#add 'combo-menu' for choosing luminos mount to move
		self.luminos_combo_box = gtk.combo_box_new_text()
		self.luminos_combo_box.show()
        	self.luminos_combo_box.set_wrap_width(1)
       	 	for i in range(self.n):
            		self.luminos_combo_box.append_text('Luminos Stage # %d' % (i+1))
        	self.luminos_combo_box.set_active(self.stage-1)
        	self.luminos_combo_box.connect("changed",self.luminos_menu_changed)
		self.luminos_table.attach(self.luminos_combo_box,0,1,0,1,xoptions = False|True,yoptions = False|True,xpadding = 10, ypadding = 10)
			
		#joystick for moving x and y (has it's own table withing luminos_table)
		
		self.joystick_table = gtk.Table(5,3,True)

		self.luminos_table.attach(self.joystick_table,0,1,1,2,xoptions = False|True,yoptions = False|True)
		
		self.left_xy_button = self.create_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_IN)
		self.left_xy_button.connect('clicked',self.move,'LEFT')
		self.joystick_table.attach(self.left_xy_button,0,1,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.right_xy_button = self.create_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_IN)
		self.right_xy_button.connect('clicked',self.move,'RIGHT')
		self.joystick_table.attach(self.right_xy_button,2,3,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
    		self.up_xy_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.up_xy_button.connect('clicked',self.move,'UP')
		self.joystick_table.attach(self.up_xy_button,1,2,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.down_xy_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.down_xy_button.connect('clicked',self.move,'DOWN')
		self.joystick_table.attach(self.down_xy_button,1,2,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.in_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.in_z_button.connect('clicked',self.move,'IN')
		self.joystick_table.attach(self.in_z_button,4,5,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.out_z_button.connect('clicked',self.move,'OUT')
		self.joystick_table.attach(self.out_z_button,4,5,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	
		
		#add labels to joystick buttons
		self.xy_label = gtk.Label('XY')
		self.joystick_table.attach(self.xy_label,1,2,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.xy_label.show()
		
		self.z_label = gtk.Label('Z')
		self.joystick_table.attach(self.z_label,4,5,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.z_label.show()
		
		self.joystick_table.show()
		
		#now add 'spin buttons' to select step size of xy and z motion
		
		#for xy, clicking w/left button increments 0.5 microns, clicking with right increments .004 microns (one step)
		self.xy_adjustment = gtk.Adjustment(value=2.000, lower=0.004, upper=50., step_incr=0.004, page_incr=.5, page_size=0)
		self.xy_spin_button = gtk.SpinButton(adjustment=self.xy_adjustment, climb_rate=0.0, digits=3)
		#constrain entered values to numbers (not letters)
		self.xy_spin_button.set_numeric(numeric=True)
		#do not wrap from 100 microns to 0.
		self.xy_spin_button.set_wrap(wrap=False)
		#if user enters a non-multiple of 0.004, the number is rounded off
		self.xy_spin_button.set_snap_to_ticks(snap_to_ticks=True)
		#only change the value entered if it is a number within range
		self.xy_spin_button.set_update_policy(gtk.UPDATE_IF_VALID)
		self.xy_spin_button.show()
		
		#now for z, left button does 0.1 microns, right does 10
		self.z_adjustment = gtk.Adjustment(value=10., lower=0.1, upper=500.0, step_incr=0.1, page_incr=5, page_size=0)
		self.z_spin_button = gtk.SpinButton(adjustment=self.z_adjustment, climb_rate=0.0, digits=1)
		#constrain entered values to numbers (not letters)
		self.z_spin_button.set_numeric(numeric=True)
		#do not wrap from 100 microns to 0.
		self.z_spin_button.set_wrap(wrap=False)
		#if user enters a non-multiple of 0.1, the number is rounded off
		self.z_spin_button.set_snap_to_ticks(snap_to_ticks=True)
		#only change the value entered if it is a number within range
		self.z_spin_button.set_update_policy(gtk.UPDATE_IF_VALID)
		self.z_spin_button.connect("value_changed",self.z_spin_button_changed)
		self.z_spin_button.show()
		
		#add these to the luminos_table in it's own table with lables
		self.spin_button_table = gtk.Table(2,3,False)
		#add spin_table to luminos table
		self.luminos_table.attach(self.spin_button_table,1,2,0,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		#add spin buttons and lables to spin_table
		self.spin_button_table.attach(self.xy_spin_button,1,2,0,1,xpadding = 2, ypadding = 2)
		self.spin_button_table.attach(self.z_spin_button,1,2,1,2,xpadding = 2, ypadding = 2)
		self.xy_spin_label = gtk.Label('XY step size:')
		self.xy_spin_label.show()
		self.z_spin_label = gtk.Label('Z step size:')
		self.z_spin_label.show()
		self.microns_label = gtk.Label('microns')
		self.microns_label.show()
		self.spin_button_table.attach(self.xy_spin_label,0,1,0,1,xpadding = 2, ypadding = 2)
		self.spin_button_table.attach(self.z_spin_label,0,1,1,2,xpadding = 2, ypadding = 2)
		self.spin_button_table.attach(self.microns_label,2,3,0,2,xpadding = 2, ypadding = 2)
		self.spin_button_table.show()
		
		#Directly enter position for Luminos:
		#x edittable box & label:
		self.x_position_entry = gtk.Entry(max=6)
		self.x_position_entry.set_text(str(0))
		self.x_position_entry.show()
		self.x_position_entry_label = gtk.Label('X pos in steps')
		self.x_position_entry_label.show()
		
		#y edittable box & label:
		self.y_position_entry = gtk.Entry(max=6)
		self.y_position_entry.set_text(str(0))
		self.y_position_entry.show()
		self.y_position_entry_label = gtk.Label('Y pos in steps')
		self.y_position_entry_label.show()
		
		#z edittable box & label:	
		self.z_position_entry = gtk.Entry(max=6)
		self.z_position_entry.set_text(str(0))
		self.z_position_entry.show()
		self.z_position_entry_label = gtk.Label('Z pos in steps')
		self.z_position_entry_label.show()		
		
		#create a table to hold these
		self.position_table = gtk.Table(4,3,False)
		self.position_table.show()
		self.position_table.attach(self.x_position_entry,1,2,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.position_table.attach(self.x_position_entry_label,0,1,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.position_table.attach(self.y_position_entry,1,2,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.position_table.attach(self.y_position_entry_label,0,1,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.position_table.attach(self.z_position_entry,1,2,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.position_table.attach(self.z_position_entry_label,0,1,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		#Attach position_tabel to luminos_table
		self.luminos_table.attach(self.position_table,0,1,2,3,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)
		
		#Add more control buttons to move to an enterred position
		#self.move_button_label = gtk.Label('Move to')
		self.move_button = gtk.Button('Move to')
		self.move_button.connect("clicked",self.move_to_enterred)
		self.move_button.show()
		#self.move_button_label.show()		

		#self.refresh_button_label = gtk.Label('Refresh')
		self.refresh_button = gtk.Button('Refresh')
		self.refresh_button.connect("clicked",self.refresh_positions)
		#self.refresh_button_label.show()
		self.refresh_button.show()

		#self.index_button_label = gtk.Label('Index as')
		self.index_button = gtk.Button('Index as')
		self.index_button.connect("clicked",self.index_to_enterred)
		self.index_button.show()
		#self.index_button_label.show()		

		#self.renumber_button_label = gtk.Label('Renumber')
		self.renumber_button = gtk.Button('Renumber')
		self.renumber_button.connect("clicked",self.renumber_mount)
		#self.renumber_button_label.show()
		self.renumber_button.show()

		self.home_all_button = gtk.Button('Home All')
		self.home_all_button.show()
		self.home_all_button.connect("clicked",self.home_mount,True)

		self.restart_button = gtk.Button('Restart')
		self.restart_button.show()
		self.restart_button.connect("clicked",self.restart_mounts)

		#self.home_button_label = gtk.Label('Home this mount')
		self.home_button = gtk.Button('Home this mount')
		self.home_button.connect("clicked",self.home_mount)
		#self.home_button_label.show()
		self.home_button.show()

		self.save_position_button = gtk.Button('Save all positions to file')
		self.save_position_button.connect("clicked",self.save_pos)
		#self.save_position_label = gtk.Label('Save Position to File')
		#self.save_position_button.add(self.save_position_label)
		#self.luminos_table.attach(self.save_position_button,0,1,3,4,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)
		#self.save_position_label.show()
		self.save_position_button.show()
		
		self.recall_position_button = gtk.Button('Recall all positions from file')
		self.recall_position_button.connect("clicked",self.recall_pos)
		#self.recall_position_label = gtk.Label('Recall Position from File')
		#self.recall_position_button.add(self.recall_position_label)
		#self.luminos_table.attach(self.recall_position_button,1,2,3,4,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)
		#self.recall_position_label.show()
		self.recall_position_button.show()

		#create a table  buttons
		self.position_button_table = gtk.Table(2,3,False)
		self.position_button_table.show()
		self.luminos_table.attach(self.position_button_table,1,2,2,3,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)
		self.position_button_table.attach(self.move_button,0,1,0,1,xpadding = 2, ypadding = 2)
		self.position_button_table.attach(self.refresh_button,0,1,1,2,xpadding = 2, ypadding = 2)
		self.position_button_table.attach(self.index_button,0,1,2,3,xpadding = 2, ypadding = 2)
		self.position_button_table.attach(self.home_button,1,2,0,1,xpadding = 2, ypadding = 2)
		self.position_button_table.attach(self.save_position_button,1,2,1,2,xpadding = 2, ypadding = 2)
		self.position_button_table.attach(self.recall_position_button,1,2,2,3,xpadding = 2, ypadding = 2)
		
		self.renumber_home_all_table = gtk.Table(1,3,False)
		self.renumber_home_all_table.show()
		self.renumber_home_all_table.attach(self.home_all_button,0,1,0,1,xoptions = False,yoptions=False,xpadding=2,ypadding=2)
		self.renumber_home_all_table.attach(self.renumber_button,1,2,0,1,xoptions = False,yoptions=False,xpadding=2,ypadding=2)
		self.renumber_home_all_table.attach(self.restart_button,2,3,0,1,xoptions = False,yoptions=False,xpadding=2,ypadding=2)
		self.luminos_table.attach(self.renumber_home_all_table,1,2,3,4,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)


		#toggle switch to automatically view detector section
		self.auto_det_section = 0
		self.auto_det_section_check = gtk.CheckButton('View detector section after each move')
		self.auto_det_section_check.show()
		self.auto_det_section_check.connect("toggled",self.auto_det_section_toggled)

		self.luminos_table.attach(self.auto_det_section_check,0,1,3,4,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)

		#############################################
		

		#############  MAPPING TAB  #################		
		
		#add combo menu for choosing which mount to move
		self.mapping_combo_box = gtk.combo_box_new_text()
		self.mapping_combo_box.show()
        	self.mapping_combo_box.set_wrap_width(1)
       	 	for i in range(self.n):
            		self.mapping_combo_box.append_text('Luminos Stage # %d' % (i+1))
        	self.mapping_combo_box.set_active(self.stage - 1)
        	self.mapping_combo_box.connect("changed",self.luminos_menu_changed)
		self.mapping_table.attach(self.mapping_combo_box,0,1,0,1,xoptions = False,yoptions = False,xpadding = 10, ypadding = 10)

		#add spin buttons for xy range and step for a map:
		self.xy_range_adjustment = gtk.Adjustment(value=20., lower=0.004, upper=500., step_incr=0.004, page_incr=2, page_size=0)
		self.xy_range_spin_button = gtk.SpinButton(adjustment=self.xy_range_adjustment, climb_rate=0.0, digits=3)
		#constrain entered values to numbers (not letters)
		self.xy_range_spin_button.set_numeric(numeric=True)
		#do not wrap around.
		self.xy_range_spin_button.set_wrap(wrap=False)
		#if user enters a non-multiple of 0.1, the number is rounded off
		self.xy_range_spin_button.set_snap_to_ticks(snap_to_ticks=True)
		#only change the value entered if it is a number within range
		self.xy_range_spin_button.set_update_policy(gtk.UPDATE_IF_VALID)
		self.xy_range_spin_button.show()
		
		self.xy_step_adjustment = gtk.Adjustment(value=2., lower=0.004, upper=500.0, step_incr=0.004, page_incr=1, page_size=0)
		self.xy_step_spin_button = gtk.SpinButton(adjustment=self.xy_step_adjustment, climb_rate=0.0, digits=3)
		#constrain entered values to numbers (not letters)
		self.xy_step_spin_button.set_numeric(numeric=True)
		#do not wrap from 100 microns to 0.
		self.xy_step_spin_button.set_wrap(wrap=False)
		#if user enters a non-multiple of 0.1, the number is rounded off
		self.xy_step_spin_button.set_snap_to_ticks(snap_to_ticks=True)
		#only change the value entered if it is a number within range
		self.xy_step_spin_button.set_update_policy(True)
		self.xy_step_spin_button.show()

		self.xy_range_label = gtk.Label('XY Range:')
		self.xy_range_label.show()
		self.xy_step_label = gtk.Label('XY Step: ')
		self.xy_step_label.show()
		self.xy_map_microns = gtk.Label('microns')
		self.xy_map_microns.show()

		self.xy_map_table = gtk.Table(2,3)
		self.xy_map_table.show()
		self.xy_map_table.attach(self.xy_range_label,0,1,0,1,xpadding = 2, ypadding = 2)
		self.xy_map_table.attach(self.xy_step_label,0,1,1,2,xpadding = 2, ypadding = 2)
		self.xy_map_table.attach(self.xy_range_spin_button,1,2,0,1,xpadding = 2, ypadding = 2)
		self.xy_map_table.attach(self.xy_step_spin_button,1,2,1,2,xpadding = 2, ypadding = 2)
		self.xy_map_table.attach(self.xy_map_microns,2,3,0,2,xpadding = 2, ypadding = 2)

		self.mapping_table.attach(self.xy_map_table,0,1,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		#test for "changed" signal in spin buttons:
		#self.xy_step_spin_button.connect("value_changed",self.xy_step_spin_button_changed)
		
		#insert button to perform the mapping
		self.xy_mapping_button = gtk.Button('Perform Map')
		self.xy_mapping_button.show()
		self.xy_mapping_button.connect("clicked",self.map_it_up)

		#insert button to add another map to the current one
		self.add_mapping_button = gtk.Button('Add to Last Map')
		self.add_mapping_button.show()
		self.add_mapping_button.connect("clicked",self.map_it_up,True)
		
		self.mapping_buttons_table = gtk.Table(1,2,True)
		self.mapping_buttons_table.show()
		self.mapping_buttons_table.attach(self.xy_mapping_button,0,1,0,1, xpadding = 2, ypadding = 2)
		self.mapping_buttons_table.attach(self.add_mapping_button,1,2,0,1, xpadding = 2, ypadding = 2)	
		
		self.mapping_table.attach(self.mapping_buttons_table,1,2,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	
		
		#Focus control
		self.in_z_map_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.in_z_map_button.connect('clicked',self.move,'IN')
		self.in_z_map_button.show()
				
		self.out_z_map_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.out_z_map_button.connect('clicked',self.move,'OUT')
		self.in_z_map_button.show()			

		self.z_button_label = gtk.Label('Z')
		self.z_button_label.show()

		self.z_map_adjustment = gtk.Adjustment(value=10., lower=0.1, upper=500.0, step_incr=0.1, page_incr=5, page_size=0)
		self.z_map_spin_button = gtk.SpinButton(adjustment=self.z_map_adjustment, climb_rate=0.0, digits=1)
		#constrain entered values to numbers (not letters)
		self.z_map_spin_button.set_numeric(numeric=True)
		#do not wrap from 100 microns to 0.
		self.z_map_spin_button.set_wrap(wrap=False)
		#if user enters a non-multiple of 0.1, the number is rounded off
		self.z_map_spin_button.set_snap_to_ticks(snap_to_ticks=True)
		#only change the value entered if it is a number within range
		self.z_map_spin_button.set_update_policy(False)
		self.z_map_spin_button.connect("value_changed",self.z_map_spin_button_changed)
		self.z_map_spin_button.show()

		self.z_map_spin_button_label = gtk.Label('step size:')		
		self.z_map_spin_button_label.show()
		self.z_map_spin_button_microns = gtk.Label('microns')		
		self.z_map_spin_button_microns.show()	
		
		#display z position in microns:
		self.z_position_microns_label = gtk.Label('Z pos:')
		self.z_position_microns_label.show()
		self.z_position_microns_microns = gtk.Label('microns')
		self.z_position_microns_microns.show()

		self.z_position_microns = gtk.Entry()
		self.z_position_microns.show()
		#self.z_position_microns.set_text(str(absolute_position(self.stage,1))
		self.z_position_microns.set_editable(False)

		self.change_focus_table = gtk.Table(3,4,False)
		self.change_focus_table.show()
		self.change_focus_table.attach(self.in_z_map_button,0,1,0,1)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.change_focus_table.attach(self.out_z_map_button,0,1,2,3)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.change_focus_table.attach(self.z_button_label,0,1,1,2)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.change_focus_table.attach(self.z_map_spin_button_label,1,2,1,2)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.change_focus_table.attach(self.z_map_spin_button,2,3,1,2)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.change_focus_table.attach(self.z_map_spin_button_microns,3,4,1,2)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.focus_position_table = gtk.Table(1,3,False)
		self.focus_position_table.show()
		self.focus_position_table.attach(self.z_position_microns_label,0,1,0,1,xpadding = 2, ypadding = 2)		
		self.focus_position_table.attach(self.z_position_microns,1,2,0,1,xpadding = 2, ypadding = 2)	
		self.focus_position_table.attach(self.z_position_microns_microns,2,3,0,1,xpadding = 2, ypadding = 2)	

		self.mapping_table.attach(self.change_focus_table,0,1,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.mapping_table.attach(self.focus_position_table,0,1,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.mapping_settings_label = gtk.Label('Settings')
		self.mapping_settings_label.show()
		
		self.move_to_max = 0
		self.move_to_max_check = gtk.CheckButton('Move to max after mapping')
		self.move_to_max_check.show()
		self.move_to_max_check.connect("toggled",self.move_to_max_toggled)

		self.move_to_gauss_peak = 0
		self.move_to_gauss_peak_check = gtk.CheckButton('Move to Gauss peak after mapping')
		self.move_to_gauss_peak_check.show()
		self.move_to_gauss_peak_check.connect("toggled",self.move_to_gauss_peak_toggled)

		self.display_as_mapped = 0
		self.display_as_mapped_check = gtk.CheckButton('Display image while mapping')
		self.display_as_mapped_check.show()
		self.display_as_mapped_check.connect("toggled",self.display_as_mapped_toggled)

		self.show_surface_after = 0
		self.show_surface_after_check = gtk.CheckButton('Show surface after mapping')
		self.show_surface_after_check.show()
		self.show_surface_after_check.connect("toggled",self.show_surface_after_toggled)

		self.show_image_after = 0
		self.show_image_after_check = gtk.CheckButton('Show image after mapping')
		self.show_image_after_check.show()
		self.show_image_after_check.connect("toggled",self.show_image_after_toggled)

		self.mapping_settings_table = gtk.Table(6,1,False)
		self.mapping_settings_table.show()

		self.mapping_settings_table.attach(self.mapping_settings_label,0,1,0,1)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.mapping_settings_table.attach(self.move_to_max_check,0,1,1,2)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	
		self.mapping_settings_table.attach(self.move_to_gauss_peak_check,0,1,2,3)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	
		self.mapping_settings_table.attach(self.display_as_mapped_check,0,1,3,4)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.mapping_settings_table.attach(self.show_surface_after_check,0,1,4,5)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		self.mapping_settings_table.attach(self.show_image_after_check,0,1,5,6)#,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.mapping_table.attach(self.mapping_settings_table,0,1,4,5,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		#now print the position of the last maximum and it's intensity
		self.last_max_x_label = gtk.Label('Max X:')
		self.last_max_x_label.show()
		self.last_max_y_label = gtk.Label('Max Y:')
		self.last_max_y_label.show()		
		self.last_max_z_label = gtk.Label('Z:')
		self.last_max_z_label.show()
		self.last_max_intensity_label = gtk.Label('Max intensity:')
		self.last_max_intensity_label.show()

		self.last_max_x_text = gtk.Entry(max=6)
		self.last_max_x_text.show()
		self.last_max_x_text.set_text('0')
		self.last_max_x_text.set_editable(False) 
		
		self.last_max_y_text = gtk.Entry(max=6)
		self.last_max_y_text.show()
		self.last_max_y_text.set_text('0')
		self.last_max_y_text.set_editable(False)

		self.last_max_z_text = gtk.Entry(max=6)
		self.last_max_z_text.show()
		self.last_max_z_text.set_text('0')
		self.last_max_z_text.set_editable(False)

		self.last_max_intensity_text = gtk.Entry(max=6)
		self.last_max_intensity_text.show()
		self.last_max_intensity_text.set_text('0')
		self.last_max_intensity_text.set_editable(False)		

		self.last_max_table = gtk.Table(4,3,False)
		self.last_max_table.show()

		self.last_max_table.attach(self.last_max_x_label,0,1,0,1)
		self.last_max_table.attach(self.last_max_y_label,0,1,1,2)
		self.last_max_table.attach(self.last_max_z_label,0,1,2,3)
		self.last_max_table.attach(self.last_max_intensity_label,0,1,3,4)
		
		self.last_max_table.attach(self.last_max_x_text,1,2,0,1)
		self.last_max_table.attach(self.last_max_y_text,1,2,1,2)
		self.last_max_table.attach(self.last_max_z_text,1,2,2,3)
		self.last_max_table.attach(self.last_max_intensity_text,1,2,3,4)

		self.mapping_table.attach(self.last_max_table,1,2,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.move_to_last_max_button = gtk.Button('Move to last max')
		self.move_to_last_max_button.show()
		self.move_to_last_max_button.connect("clicked",self.move_to_last_max)
		
		self.move_to_last_gauss_button = gtk.Button('Move to Gauss peak')
		self.move_to_last_gauss_button.show()
		self.move_to_last_gauss_button.connect("clicked",self.move_to_last_gauss)

		self.show_last_surface_button = gtk.Button('Surface of last map')
		self.show_last_surface_button.show()
		self.show_last_surface_button.connect("clicked",self.show_last_surface)

		self.show_last_image_button = gtk.Button('Image of last map')
		self.show_last_image_button.show()
		self.show_last_image_button.connect("clicked",self.show_last_image)

		self.show_last_gauss_button = gtk.Button('Contour of Gauss fit')
		self.show_last_gauss_button.show()
		self.show_last_gauss_button.connect("clicked",self.show_last_gauss)

		self.last_button_table = gtk.Table(3,1,False)
		self.last_button_table.show()
		self.last_button_table.attach(self.move_to_last_max_button,0,1,0,1,xpadding = 2,ypadding = 2)
		self.last_button_table.attach(self.show_last_surface_button,0,1,1,2,xpadding = 2,ypadding = 2)
		self.last_button_table.attach(self.show_last_image_button,0,1,2,3,xpadding = 2,ypadding = 2)
		
		self.last_max_table.attach(self.last_button_table,2,3,0,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.last_gauss_x_label = gtk.Label('Gauss peak X:')
		self.last_gauss_x_label.show()
		self.last_gauss_y_label = gtk.Label('Gauss peak Y:')
		self.last_gauss_y_label.show()		
		self.last_gauss_sigma_x_label = gtk.Label('FWHM X')
		self.last_gauss_sigma_x_label.show()
		self.last_gauss_sigma_y_label = gtk.Label('FWHM Y')
		self.last_gauss_sigma_y_label.show()		

		self.last_gauss_x_text = gtk.Entry(max=6)
		self.last_gauss_x_text.show()
		self.last_gauss_x_text.set_text(str(self.last_gauss_x))
		self.last_gauss_x_text.set_editable(False) 
		
		self.last_gauss_y_text = gtk.Entry(max=6)
		self.last_gauss_y_text.show()
		self.last_gauss_y_text.set_text(str(self.last_gauss_y))
		self.last_gauss_y_text.set_editable(False)

		self.last_gauss_sigma_x_text = gtk.Entry(max=6)
		self.last_gauss_sigma_x_text.show()
		self.last_gauss_sigma_x_text.set_text(str(self.last_gauss_sigma_x))
		self.last_gauss_sigma_x_text.set_editable(False)
	
		self.last_gauss_sigma_y_text = gtk.Entry(max=6)
		self.last_gauss_sigma_y_text.show()
		self.last_gauss_sigma_y_text.set_text(str(self.last_gauss_sigma_y))
		self.last_gauss_sigma_y_text.set_editable(False)

		self.last_gauss_table = gtk.Table(4,3,False)
		self.last_gauss_table.show()

		self.last_gauss_table.attach(self.last_gauss_x_label,0,1,0,1)
		self.last_gauss_table.attach(self.last_gauss_y_label,0,1,1,2)
		self.last_gauss_table.attach(self.last_gauss_sigma_x_label,0,1,2,3)
		self.last_gauss_table.attach(self.last_gauss_sigma_y_label,0,1,3,4)
				
		self.last_gauss_table.attach(self.last_gauss_x_text,1,2,0,1)
		self.last_gauss_table.attach(self.last_gauss_y_text,1,2,1,2)
		self.last_gauss_table.attach(self.last_gauss_sigma_x_text,1,2,2,3)
		self.last_gauss_table.attach(self.last_gauss_sigma_y_text,1,2,3,4)
		
		#self.last_gauss_buttons_table = gtk.Table(2,1,True)
		#self.last_gauss_buttons_table.show()

		#self.last_gauss_buttons_table.attach(self.move_to_last_gauss_button,0,1,0,1,yoptions = False,xpadding = 2, ypadding = 2)
		#self.last_gauss_buttons_table.attach(self.show_last_gauss_button,0,1,1,2,yoptions = False,xpadding = 2, ypadding = 2)
		self.last_gauss_table.attach(self.move_to_last_gauss_button,2,3,0,1,xpadding = 2)#, ypadding = 2)
		self.last_gauss_table.attach(self.show_last_gauss_button,2,3,1,2,xpadding = 2)#,ypadding = 2)

		self.last_gauss_sigma_microns = gtk.Label('microns')
		self.last_gauss_sigma_microns.show()

		self.last_gauss_table.attach(self.last_gauss_sigma_microns,2,3,2,4,xpadding = 2)#,ypadding = 2)

		self.mapping_table.attach(self.last_gauss_table,1,2,2,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		#add button to get current intensity
		self.get_intensity_button = gtk.Button('Get current intensity')
		self.get_intensity_button.connect("clicked",self.get_current_intensity)
		self.get_intensity_button.show()

		#add text box to display current intensity
		self.get_intensity_text = gtk.Entry()
		self.get_intensity_text.set_text(str(self.current_intensity))
		self.get_intensity_text.set_editable(False)
		self.get_intensity_text.show()

		#create a table to hold these widgets
		self.get_intensity_table = gtk.Table(1,2,False)
		self.get_intensity_table.show()
		self.get_intensity_table.attach(self.get_intensity_button,0,1,0,1,xpadding = 2, ypadding = 2)
		self.get_intensity_table.attach(self.get_intensity_text,1,2,0,1,xpadding = 2,ypadding = 2)

		self.mapping_table.attach(self.get_intensity_table,1,2,4,5,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		#############################################

		############ Detector Tab ###################

		#create a bunch of buttons
		self.configure_detector_button = gtk.Button('Configure Detector')
		self.configure_detector_button.connect("clicked",self.configure_detector)
		self.configure_detector_button.show()

		self.free_detector_button = gtk.Button('Free Detector Memory')
		self.free_detector_button.connect("clicked",self.free_detector)
		self.free_detector_button.show()

		#give these their own table
		self.configure_table = gtk.Table(2,1,True)
		self.configure_table.show()
		self.configure_table.attach(self.configure_detector_button,0,1,0,1,yoptions = False,xpadding = 2,ypadding = 2)
		self.configure_table.attach(self.free_detector_button,0,1,1,2,yoptions = False,xpadding = 2,ypadding = 2)		
		
		self.detector_table.attach(self.configure_table,0,1,1,2,xoptions=False|True,yoptions=False|True,xpadding = 2,ypadding = 2)	
		
		self.view_detector_section_button = gtk.Button('View section of detector')
		self.view_detector_section_button.connect("clicked",self.view_detector_section)
		self.view_detector_section_button.show()

		self.view_whole_detector_button = gtk.Button('View whole detector')
		self.view_whole_detector_button.connect("clicked",self.view_whole_detector)
		self.view_whole_detector_button.show()

		self.save_image_button = gtk.Button('Save image to file')
		self.save_image_button.connect("clicked",self.save_image)
		self.save_image_button.show()
		
		self.view_cross_section_button = gtk.Button('View cross section')
		self.view_cross_section_button.connect("clicked",self.view_cross_section)
		self.view_cross_section_button.show()
		
		self.run_do_loop_button = gtk.Button('Run do loop')
		self.run_do_loop_button.connect("clicked",self.run_do_loop)
		self.run_do_loop_button.show()

		#pack these into a table
		self.detector_buttons_table = gtk.Table(5,1,True)
		self.detector_buttons_table.show()
		self.detector_buttons_table.attach(self.view_detector_section_button,0,1,0,1,xpadding =2,ypadding=2)
		self.detector_buttons_table.attach(self.view_whole_detector_button,0,1,1,2,xpadding =2,ypadding=2)	
		self.detector_buttons_table.attach(self.save_image_button,0,1,2,3,xpadding =2,ypadding=2)
		self.detector_buttons_table.attach(self.view_cross_section_button,0,1,3,4,xpadding =2,ypadding=2)
		self.detector_buttons_table.attach(self.run_do_loop_button,0,1,4,5,xpadding =2,ypadding=2)

		#pack this into the detector table
		self.detector_table.attach(self.detector_buttons_table,0,1,0,1,xoptions=False|True,yoptions=False|True,xpadding=2,ypadding=2)
		
		#now make some labels and spin buttons for changing settings
		self.pixel_range_label = gtk.Label('Pixel range, img[a:b][c:d]')
		self.pixel_range_label.show()

		self.a_label = gtk.Label('a:')
		self.b_label = gtk.Label('b:')
		self.c_label = gtk.Label('c:')
		self.d_label = gtk.Label('d:')

		self.a_label.show()
		self.b_label.show()
		self.c_label.show()
		self.d_label.show()

		self.a_adjustment = gtk.Adjustment(value=0, lower=0, upper=256, step_incr=1, page_incr=0, page_size=0)		
		self.c_adjustment = gtk.Adjustment(value=0, lower=0, upper=256, step_incr=1, page_incr=0, page_size=0)
		self.b_adjustment = gtk.Adjustment(value=256, lower=0, upper=256, step_incr=1, page_incr=0, page_size=0)	
		self.d_adjustment = gtk.Adjustment(value=256, lower=0, upper=256, step_incr=1, page_incr=0, page_size=0)
		
		self.a_spin_button = gtk.SpinButton(adjustment=self.a_adjustment, climb_rate=0.0, digits=0)
		self.b_spin_button = gtk.SpinButton(adjustment=self.b_adjustment, climb_rate=0.0, digits=0)
		self.c_spin_button = gtk.SpinButton(adjustment=self.c_adjustment, climb_rate=0.0, digits=0)
		self.d_spin_button = gtk.SpinButton(adjustment=self.d_adjustment, climb_rate=0.0, digits=0)
		
		self.a_spin_button.set_numeric(True)
		self.b_spin_button.set_numeric(True)
		self.c_spin_button.set_numeric(True)	
		self.d_spin_button.set_numeric(True)

		self.a_spin_button.set_wrap(False)
		self.b_spin_button.set_wrap(False)
		self.c_spin_button.set_wrap(False)	
		self.d_spin_button.set_wrap(False)

		self.a_spin_button.set_update_policy(True)
		self.b_spin_button.set_update_policy(True)
		self.c_spin_button.set_update_policy(True)	
		self.d_spin_button.set_update_policy(True)

		self.a_spin_button.connect("value_changed",self.img_changed,'a')
		self.b_spin_button.connect("value_changed",self.img_changed,'b')
		self.c_spin_button.connect("value_changed",self.img_changed,'c')	
		self.d_spin_button.connect("value_changed",self.img_changed,'d')
		
		self.a_spin_button.show()
		self.b_spin_button.show()
		self.c_spin_button.show()
		self.d_spin_button.show()
		
		#make tables to attach label to spin button
		self.a_table = gtk.Table(1,2,False)
		self.a_table.show()
		self.a_table.attach(self.a_label,0,1,0,1)
		self.a_table.attach(self.a_spin_button,1,2,0,1)

		self.b_table = gtk.Table(1,2,False)
		self.b_table.show()
		self.b_table.attach(self.b_label,0,1,0,1)
		self.b_table.attach(self.b_spin_button,1,2,0,1)

		self.c_table = gtk.Table(1,2,False)
		self.c_table.show()
		self.c_table.attach(self.c_label,0,1,0,1)
		self.c_table.attach(self.c_spin_button,1,2,0,1)

		self.d_table = gtk.Table(1,2,False)
		self.d_table.show()
		self.d_table.attach(self.d_label,0,1,0,1)
		self.d_table.attach(self.d_spin_button,1,2,0,1)
		
		#now create stuff for the cross section
		self.cross_section_label = gtk.Label('Cross sectrion across img[:][e]')
		self.cross_section_label.show()
		self.e_label = gtk.Label('e:')
		self.e_label.show()

		self.e_adjustment = gtk.Adjustment(value=125, lower=0, upper=256, step_incr=1, page_incr=0, page_size=0)
		self.e_spin_button = gtk.SpinButton(adjustment=self.e_adjustment,climb_rate=0.0,digits=0)
		self.e_spin_button.show()

		self.cross_section_table = gtk.Table(1,2,False)
		self.cross_section_table.show()
		self.cross_section_table.attach(self.e_label,0,1,0,1)#,xpadding = 2,ypadding = 2)
		self.cross_section_table.attach(self.e_spin_button,1,2,0,1)#,xpadding = 2,ypadding =2)
		
		#now create stuff for the interations
		self.do_loop_label = gtk.Label('Do loop iterations:')
		self.do_loop_label.show()
		self.do_loop_iteration_adjustment = gtk.Adjustment(value=1, lower=0, upper=10000, step_incr=5, page_incr=0, page_size=0)
		self.do_loop_spin_button = gtk.SpinButton(adjustment = self.do_loop_iteration_adjustment,climb_rate=0.0,digits=0)
		self.do_loop_spin_button.show()
		#pack these into a table
		#self.do_loop_table = gtk.Table(1,2,False)
		#self.do_loop_table.show()
		#self.do_loop_table.attach(self.do_loop_label,0,1,0,1,xpadding = 2,ypadding=2)
		#self.do_loop_table.attach(self.do_loop_spin_button,1,2,0,1,xpadding=2,ypadding=2)

		#now for exposure time
		self.exp_time_label = gtk.Label('Exposure time:')
		self.exp_time_label.show()
		self.exp_time_adjustment = gtk.Adjustment(value=1000, lower=1, upper=20000, step_incr=1, page_incr=0, page_size=0)
		self.exp_time_spin_button = gtk.SpinButton(adjustment = self.exp_time_adjustment,climb_rate=0.0,digits=0)
		self.exp_time_spin_button.show()
		self.exp_time_spin_button.connect("value_changed",self.change_exp_time)
		self.exp_time_seconds = gtk.Label('milliseconds')
		self.exp_time_seconds.show()
		#pack these into a table
		#self.exp_time_table = gtk.Table(1,3,False)
		#self.exp_time_table.show()
		#self.exp_time_table.attach(self.exp_time_label,0,1,0,1,xpadding = 2,ypadding=2)
		#self.exp_time_table.attach(self.exp_time_spin_button,1,2,0,1,xpadding=2,ypadding=2)
		#self.exp_time_table.attach(self.exp_time_seconds,2,3,0,1,xpadding=2,ypadding=2)

		#pack this all into one big table
		self.detector_settings_table = gtk.Table(6,2,False)
		self.detector_settings_table.show()
		self.detector_settings_table.attach(self.pixel_range_label,0,2,0,1,xpadding=2,ypadding=2)
		self.detector_settings_table.attach(self.a_table,0,1,1,2,xpadding=2,ypadding=2)
		self.detector_settings_table.attach(self.b_table,1,2,1,2,xpadding=2,ypadding=2)
		self.detector_settings_table.attach(self.c_table,0,1,2,3,xpadding=2,ypadding=2)
		self.detector_settings_table.attach(self.d_table,1,2,2,3,xpadding=2,ypadding=2)
		self.detector_settings_table.attach(self.cross_section_label,0,2,3,4,xpadding=2,ypadding=2)
		self.detector_settings_table.attach(self.cross_section_table,0,1,4,5,xpadding=2,ypadding=2)
		#self.detector_settings_table.attach(self.do_loop_label,0,1,5,6,xpadding=2,ypadding=2)
		#self.detector_settings_table.attach(self.do_loop_spin_button,1,2,5,6,xpadding=2,ypadding=2)
		#self.detector_settings_table.attach(self.do_loop_table,0,2,5,6,xoptions=False,xpadding=2,ypadding=2)
		#self.detector_settings_table.attach(self.exp_time_table,0,2,6,7,xoptions=False,xpadding=2,ypadding=2)
		#self.detector_settings_table.attach(self.exp_time_label	
		
		self.detector_settings_table2 = gtk.Table(2,3,False)
		self.detector_settings_table2.show()
		self.detector_settings_table2.attach(self.do_loop_label,0,1,0,1,xpadding=2,ypadding=2)
		self.detector_settings_table2.attach(self.do_loop_spin_button,1,2,0,1,xpadding=2,ypadding=2)
		self.detector_settings_table2.attach(self.exp_time_label,0,1,1,2,xpadding=2,ypadding=2)
		self.detector_settings_table2.attach(self.exp_time_spin_button,1,2,1,2,xpadding=2,ypadding=2)
		self.detector_settings_table2.attach(self.exp_time_seconds,2,3,1,2,xpadding=2,ypadding=2)
		
		self.detector_settings_table.attach(self.detector_settings_table2,0,2,5,6,xpadding=2,ypadding=2)
		
		#now add this to the detector table
		self.detector_table.attach(self.detector_settings_table,1,2,0,1,xoptions=False|True,yoptions=False|True,xpadding=2,ypadding=2)
		#self.detector_table.attach(self.detector_settings_table2,1,2,1,2,xoptions=False|True,yoptions=False|True,xpadding=2,ypadding=2)
		
		#############################################

		######## Pick-off Mirror Delay Tab ##########
		
## 		z.configure()
		self.m = z.renumber()
		
		# set acceleration limits on aperture array and prism stages
		z.command(7,41,255)
		z.command(7,42,180)
		z.command(8,41,255)
		z.command(8,42,180)
		
		# set extension limits on all
		z.command(7,44,560000)
		z.command(8,44,560000)

		for i in range(6):
			z.command(i+1,44,210000)

		#add command to limit actuators
		
		self.actuator = 1
				
		#joystick for moving mirror in and out
		
		self.zabar_joystick_table = gtk.Table(10,3,False)

		
				
		self.zabar1_in_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.zabar1_in_z_button.connect('clicked',self.zabar_move,'IN',1)
		self.zabar_joystick_table.attach(self.zabar1_in_z_button,1,2,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.zabar1_out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.zabar1_out_z_button.connect('clicked',self.zabar_move,'OUT',1)
		self.zabar_joystick_table.attach(self.zabar1_out_z_button,1,2,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	
		
		self.zabar2_in_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.zabar2_in_z_button.connect('clicked',self.zabar_move,'IN',2)
		self.zabar_joystick_table.attach(self.zabar2_in_z_button,2,3,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.zabar2_out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.zabar2_out_z_button.connect('clicked',self.zabar_move,'OUT',2)
		self.zabar_joystick_table.attach(self.zabar2_out_z_button,2,3,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	

		self.zabar3_in_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.zabar3_in_z_button.connect('clicked',self.zabar_move,'IN',3)
		self.zabar_joystick_table.attach(self.zabar3_in_z_button,3,4,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.zabar3_out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.zabar3_out_z_button.connect('clicked',self.zabar_move,'OUT',3)
		self.zabar_joystick_table.attach(self.zabar3_out_z_button,3,4,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	

		self.zabar4_in_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.zabar4_in_z_button.connect('clicked',self.zabar_move,'IN',4)
		self.zabar_joystick_table.attach(self.zabar4_in_z_button,4,5,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.zabar4_out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.zabar4_out_z_button.connect('clicked',self.zabar_move,'OUT',4)
		self.zabar_joystick_table.attach(self.zabar4_out_z_button,4,5,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	


		self.zabar5_in_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.zabar5_in_z_button.connect('clicked',self.zabar_move,'IN',5)
		self.zabar_joystick_table.attach(self.zabar5_in_z_button,5,6,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.zabar5_out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.zabar5_out_z_button.connect('clicked',self.zabar_move,'OUT',5)
		self.zabar_joystick_table.attach(self.zabar5_out_z_button,5,6,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	

		self.zabar6_in_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.zabar6_in_z_button.connect('clicked',self.zabar_move,'IN',6)
		self.zabar_joystick_table.attach(self.zabar6_in_z_button,6,7,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.zabar6_out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.zabar6_out_z_button.connect('clicked',self.zabar_move,'OUT',6)
		self.zabar_joystick_table.attach(self.zabar6_out_z_button,6,7,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	

		self.zabar7_out_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.zabar7_out_z_button.connect('clicked',self.zabar_move,'OUT',7)
		self.zabar_joystick_table.attach(self.zabar7_out_z_button,7,8,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	

		self.zabar7_out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.zabar7_out_z_button.connect('clicked',self.zabar_move,'OUT',7)
		self.zabar_joystick_table.attach(self.zabar7_out_z_button,7,8,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	

		self.zabar8_out_z_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
		self.zabar8_out_z_button.connect('clicked',self.zabar_move,'OUT',8)
		self.zabar_joystick_table.attach(self.zabar8_out_z_button,8,9,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	

		self.zabar8_out_z_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.zabar8_out_z_button.connect('clicked',self.zabar_move,'OUT',8)
		self.zabar_joystick_table.attach(self.zabar8_out_z_button,8,9,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)	

		#add labels to joystick buttons
	
		self.zabar1_z_label = gtk.Label('IR1')
		self.zabar1_z_label.show()
		self.zabar_joystick_table.attach(self.zabar1_z_label,1,2,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		
		self.zabar2_z_label = gtk.Label('IR2')
		self.zabar2_z_label.show()
		self.zabar_joystick_table.attach(self.zabar2_z_label,2,3,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar3_z_label = gtk.Label('IR3')
		self.zabar3_z_label.show()
		self.zabar_joystick_table.attach(self.zabar3_z_label,3,4,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar4_z_label = gtk.Label('IR4')
		self.zabar4_z_label.show()
		self.zabar_joystick_table.attach(self.zabar4_z_label,4,5,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar5_z_label = gtk.Label('IR5')
		self.zabar5_z_label.show()
		self.zabar_joystick_table.attach(self.zabar5_z_label,5,6,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar6_z_label = gtk.Label('IR6')
		self.zabar6_z_label.show()
		self.zabar_joystick_table.attach(self.zabar6_z_label,6,7,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar7_z_label = gtk.Label('Pr1')
		self.zabar7_z_label.show()
		self.zabar_joystick_table.attach(self.zabar7_z_label,7,8,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar8_z_label = gtk.Label('Pr2')
		self.zabar8_z_label.show()
		self.zabar_joystick_table.attach(self.zabar8_z_label,8,9,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar_in_label = gtk.Label('In')
		self.zabar_in_label.show()
		self.zabar_joystick_table.attach(self.zabar_in_label,9,10,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar_out_label = gtk.Label('Out')
		self.zabar_out_label.show()
		self.zabar_joystick_table.attach(self.zabar_out_label,9,10,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar_opd_down_label = gtk.Label('OPD -')
		self.zabar_opd_down_label.show()
		self.zabar_joystick_table.attach(self.zabar_opd_down_label,0,1,0,1,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)

		self.zabar_opd_up_label = gtk.Label('OPD +')
		self.zabar_opd_up_label.show()
		self.zabar_joystick_table.attach(self.zabar_opd_up_label,0,1,2,3,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
	

		#add menus:
		self.zabar1_menu_bar = gtk.MenuBar()
		self.zabar1_menu_bar.show()
		
		self.zabar1_menu_name = gtk.MenuItem('Menu')
		self.zabar1_menu_name.show()		

		self.zabar1_menu = gtk.Menu()

		self.zabar1_menu_item_home = gtk.MenuItem('Home')
		self.zabar1_menu_item_good = gtk.MenuItem('Good')
		self.zabar1_menu_item_other = gtk.MenuItem('Other')

		self.zabar1_menu_item_home.show()
		self.zabar1_menu_item_good.show()
		self.zabar1_menu_item_other.show()

		self.zabar1_menu.append(self.zabar1_menu_item_home)
		self.zabar1_menu.append(self.zabar1_menu_item_good)
		self.zabar1_menu.append(self.zabar1_menu_item_other)

		self.zabar1_menu_item_home.connect_object("activate", self.zabar_home, 1)
		self.zabar1_menu_item_good.connect_object("activate", self.zabar_good, 1)
		self.zabar1_menu_item_other.connect_object("activate", self.zabar_other, 1)

		self.zabar1_menu_name.set_submenu(self.zabar1_menu)

		self.zabar1_menu_bar.append(self.zabar1_menu_name)

		self.zabar_joystick_table.attach(self.zabar1_menu_bar,1,2,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)
		

		self.zabar2_menu_bar = gtk.MenuBar()
		self.zabar2_menu_bar.show()
		
		self.zabar2_menu_name = gtk.MenuItem('Menu')
		self.zabar2_menu_name.show()		

		self.zabar2_menu = gtk.Menu()

		self.zabar2_menu_item_home = gtk.MenuItem('Home')
		self.zabar2_menu_item_good = gtk.MenuItem('Good')
		self.zabar2_menu_item_other = gtk.MenuItem('Other')

		self.zabar2_menu_item_home.show()
		self.zabar2_menu_item_good.show()
		self.zabar2_menu_item_other.show()

		self.zabar2_menu.append(self.zabar2_menu_item_home)
		self.zabar2_menu.append(self.zabar2_menu_item_good)
		self.zabar2_menu.append(self.zabar2_menu_item_other)

		self.zabar2_menu_item_home.connect_object("activate", self.zabar_home, 6)
		self.zabar2_menu_item_good.connect_object("activate", self.zabar_good, 6)
		self.zabar2_menu_item_other.connect_object("activate", self.zabar_other, 6)

		self.zabar2_menu_name.set_submenu(self.zabar2_menu)

		self.zabar2_menu_bar.append(self.zabar2_menu_name)

		self.zabar_joystick_table.attach(self.zabar2_menu_bar,2,3,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)




		self.zabar3_menu_bar = gtk.MenuBar()
		self.zabar3_menu_bar.show()
		
		self.zabar3_menu_name = gtk.MenuItem('Menu')
		self.zabar3_menu_name.show()		

		self.zabar3_menu = gtk.Menu()

		self.zabar3_menu_item_home = gtk.MenuItem('Home')
		self.zabar3_menu_item_good = gtk.MenuItem('Good')
		self.zabar3_menu_item_other = gtk.MenuItem('Other')

		self.zabar3_menu_item_home.show()
		self.zabar3_menu_item_good.show()
		self.zabar3_menu_item_other.show()

		self.zabar3_menu.append(self.zabar3_menu_item_home)
		self.zabar3_menu.append(self.zabar3_menu_item_good)
		self.zabar3_menu.append(self.zabar3_menu_item_other)

		self.zabar3_menu_item_home.connect_object("activate", self.zabar_home, 2)
		self.zabar3_menu_item_good.connect_object("activate", self.zabar_good, 2)
		self.zabar3_menu_item_other.connect_object("activate", self.zabar_other, 2)

		self.zabar3_menu_name.set_submenu(self.zabar3_menu)

		self.zabar3_menu_bar.append(self.zabar3_menu_name)

		self.zabar_joystick_table.attach(self.zabar3_menu_bar,3,4,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)




		self.zabar4_menu_bar = gtk.MenuBar()
		self.zabar4_menu_bar.show()
		
		self.zabar4_menu_name = gtk.MenuItem('Menu')
		self.zabar4_menu_name.show()		

		self.zabar4_menu = gtk.Menu()

		self.zabar4_menu_item_home = gtk.MenuItem('Home')
		self.zabar4_menu_item_good = gtk.MenuItem('Good')
		self.zabar4_menu_item_other = gtk.MenuItem('Other')

		self.zabar4_menu_item_home.show()
		self.zabar4_menu_item_good.show()
		self.zabar4_menu_item_other.show()

		self.zabar4_menu.append(self.zabar4_menu_item_home)
		self.zabar4_menu.append(self.zabar4_menu_item_good)
		self.zabar4_menu.append(self.zabar4_menu_item_other)

		self.zabar4_menu_item_home.connect_object("activate", self.zabar_home, 5)
		self.zabar4_menu_item_good.connect_object("activate", self.zabar_good, 5)
		self.zabar4_menu_item_other.connect_object("activate", self.zabar_other, 5)

		self.zabar4_menu_name.set_submenu(self.zabar4_menu)

		self.zabar4_menu_bar.append(self.zabar4_menu_name)

		self.zabar_joystick_table.attach(self.zabar4_menu_bar,4,5,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)





		self.zabar5_menu_bar = gtk.MenuBar()
		self.zabar5_menu_bar.show()
		
		self.zabar5_menu_name = gtk.MenuItem('Menu')
		self.zabar5_menu_name.show()		

		self.zabar5_menu = gtk.Menu()

		self.zabar5_menu_item_home = gtk.MenuItem('Home')
		self.zabar5_menu_item_good = gtk.MenuItem('Good')
		self.zabar5_menu_item_other = gtk.MenuItem('Other')

		self.zabar5_menu_item_home.show()
		self.zabar5_menu_item_good.show()
		self.zabar5_menu_item_other.show()

		self.zabar5_menu.append(self.zabar5_menu_item_home)
		self.zabar5_menu.append(self.zabar5_menu_item_good)
		self.zabar5_menu.append(self.zabar5_menu_item_other)

		self.zabar5_menu_item_home.connect_object("activate", self.zabar_home, 3)
		self.zabar5_menu_item_good.connect_object("activate", self.zabar_good, 3)
		self.zabar5_menu_item_other.connect_object("activate", self.zabar_other, 3)

		self.zabar5_menu_name.set_submenu(self.zabar5_menu)

		self.zabar5_menu_bar.append(self.zabar5_menu_name)

		self.zabar_joystick_table.attach(self.zabar5_menu_bar,5,6,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)




		self.zabar6_menu_bar = gtk.MenuBar()
		self.zabar6_menu_bar.show()
		
		self.zabar6_menu_name = gtk.MenuItem('Menu')
		self.zabar6_menu_name.show()		

		self.zabar6_menu = gtk.Menu()

		self.zabar6_menu_item_home = gtk.MenuItem('Home')
		self.zabar6_menu_item_good = gtk.MenuItem('Good')
		self.zabar6_menu_item_other = gtk.MenuItem('Other')

		self.zabar6_menu_item_home.show()
		self.zabar6_menu_item_good.show()
		self.zabar6_menu_item_other.show()

		self.zabar6_menu.append(self.zabar6_menu_item_home)
		self.zabar6_menu.append(self.zabar6_menu_item_good)
		self.zabar6_menu.append(self.zabar6_menu_item_other)

		self.zabar6_menu_item_home.connect_object("activate", self.zabar_home, 4)
		self.zabar6_menu_item_good.connect_object("activate", self.zabar_good, 4)
		self.zabar6_menu_item_other.connect_object("activate", self.zabar_other, 4)

		self.zabar6_menu_name.set_submenu(self.zabar6_menu)

		self.zabar6_menu_bar.append(self.zabar6_menu_name)

		self.zabar_joystick_table.attach(self.zabar6_menu_bar,6,7,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)



		self.zabar7_menu_bar = gtk.MenuBar()
		self.zabar7_menu_bar.show()
		
		self.zabar7_menu_name = gtk.MenuItem('Menu')
		self.zabar7_menu_name.show()		

		self.zabar7_menu = gtk.Menu()

		self.zabar7_menu_item_home = gtk.MenuItem('Home')
		self.zabar7_menu_item_pos1 = gtk.MenuItem('Pos1')
		self.zabar7_menu_item_pos2 = gtk.MenuItem('Pos2')
		self.zabar7_menu_item_pos3 = gtk.MenuItem('Pos3')
		self.zabar7_menu_item_pos4 = gtk.MenuItem('Pos4')
		self.zabar7_menu_item_pos5 = gtk.MenuItem('Pos5')

		self.zabar7_menu_item_home.show()
		self.zabar7_menu_item_pos1.show()
		self.zabar7_menu_item_pos2.show()
		self.zabar7_menu_item_pos3.show()
		self.zabar7_menu_item_pos4.show()
		self.zabar7_menu_item_pos5.show()
		
		self.zabar7_menu.append(self.zabar7_menu_item_home)
		self.zabar7_menu.append(self.zabar7_menu_item_pos1)
		self.zabar7_menu.append(self.zabar7_menu_item_pos2)
		self.zabar7_menu.append(self.zabar7_menu_item_pos3)
		self.zabar7_menu.append(self.zabar7_menu_item_pos4)
		self.zabar7_menu.append(self.zabar7_menu_item_pos5)

		self.zabar7_menu_item_home.connect_object("activate", self.zabar_home, 7)
		self.zabar7_menu_item_pos1.connect_object("activate", self.zabar_pos, 7,1)
		self.zabar7_menu_item_pos2.connect_object("activate", self.zabar_pos, 7,2)
		self.zabar7_menu_item_pos3.connect_object("activate", self.zabar_pos, 7,3)
		self.zabar7_menu_item_pos4.connect_object("activate", self.zabar_pos, 7,4)
		self.zabar7_menu_item_pos5.connect_object("activate", self.zabar_pos, 7,5)


		self.zabar7_menu_name.set_submenu(self.zabar7_menu)

		self.zabar7_menu_bar.append(self.zabar7_menu_name)

		self.zabar_joystick_table.attach(self.zabar7_menu_bar,7,8,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)


		self.zabar8_menu_bar = gtk.MenuBar()
		self.zabar8_menu_bar.show()
		
		self.zabar8_menu_name = gtk.MenuItem('Menu')
		self.zabar8_menu_name.show()		

		self.zabar8_menu = gtk.Menu()

		self.zabar8_menu_item_home = gtk.MenuItem('Home')
		self.zabar8_menu_item_pos1 = gtk.MenuItem('Pos1')
		self.zabar8_menu_item_pos2 = gtk.MenuItem('Pos2')
		self.zabar8_menu_item_pos3 = gtk.MenuItem('Pos3')
		self.zabar8_menu_item_pos4 = gtk.MenuItem('Pos4')
		self.zabar8_menu_item_pos5 = gtk.MenuItem('Pos5')

		self.zabar8_menu_item_in = gtk.MenuItem('In')

		self.zabar8_menu_item_home.show()
		self.zabar8_menu_item_pos1.show()
		self.zabar8_menu_item_pos2.show()
		self.zabar8_menu_item_pos3.show()
		self.zabar8_menu_item_pos4.show()
		self.zabar8_menu_item_pos5.show()
		
		self.zabar8_menu.append(self.zabar8_menu_item_home)
		self.zabar8_menu.append(self.zabar8_menu_item_pos1)
		self.zabar8_menu.append(self.zabar8_menu_item_pos2)
		self.zabar8_menu.append(self.zabar8_menu_item_pos3)
		self.zabar8_menu.append(self.zabar8_menu_item_pos4)
		self.zabar8_menu.append(self.zabar8_menu_item_pos5)

		self.zabar8_menu_item_home.connect_object("activate", self.zabar_home, 8)
		self.zabar8_menu_item_pos1.connect_object("activate", self.zabar_pos, 8,1)
		self.zabar8_menu_item_pos2.connect_object("activate", self.zabar_pos, 8,2)
		self.zabar8_menu_item_pos3.connect_object("activate", self.zabar_pos, 8,3)
		self.zabar8_menu_item_pos4.connect_object("activate", self.zabar_pos, 8,4)
		self.zabar8_menu_item_pos5.connect_object("activate", self.zabar_pos, 8,5)

		self.zabar8_menu_name.set_submenu(self.zabar8_menu)

		self.zabar8_menu_bar.append(self.zabar8_menu_name)

		self.zabar_joystick_table.attach(self.zabar8_menu_bar,8,9,3,4,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)



		self.zabar_joystick_table.show()

		#attach joystick table to notebook table
		self.zabar_table.attach(self.zabar_joystick_table,0,2,0,1,xoptions = False|True,yoptions = False|True)		

		#now add 'spin buttons' to select step size of zabar z motion
				
		#now for z, left button does 0.1 microns, right does 10
		self.zabar_z_adjustment = gtk.Adjustment(value=10., lower=0.1, upper=500.0, step_incr=0.1, page_incr=5, page_size=0)
		self.zabar_z_spin_button = gtk.SpinButton(adjustment=self.z_adjustment, climb_rate=0.0, digits=1)
		#constrain entered values to numbers (not letters)
		self.zabar_z_spin_button.set_numeric(numeric=True)
		#do not wrap from 100 microns to 0.
		self.zabar_z_spin_button.set_wrap(wrap=False)
		#if user enters a non-multiple of 0.1, the number is rounded off
		self.zabar_z_spin_button.set_snap_to_ticks(snap_to_ticks=True)
		#only change the value entered if it is a number within range
		self.zabar_z_spin_button.set_update_policy(gtk.UPDATE_IF_VALID)
		self.zabar_z_spin_button.show()

		#button to view cross section
		#self.zabar_view_cross_section_button = gtk.Button('View cross section')
		#self.zabar_view_cross_section_button.connect("clicked",self.view_cross_section)
		#self.zabar_view_cross_section_button.show()
		
		#toggle switch to automatically view cross section
		self.auto_cross_section = 0
		self.auto_cross_section_check = gtk.CheckButton('View cross section after each move')
		self.auto_cross_section_check.show()
		self.auto_cross_section_check.connect("toggled",self.auto_cross_section_toggled)		

		#add these to the zabar_table in it's own table with lables
		self.zabar_spin_button_table = gtk.Table(3,3,False)
		#add spin_table to zabar table
		
		#add spin buttons and lables to spin_table
		self.zabar_spin_button_table.attach(self.zabar_z_spin_button,1,2,0,1,xpadding = 2, ypadding = 2)
		
		self.zabar_z_spin_label = gtk.Label('Z step size:')
		self.zabar_z_spin_label.show()
		self.zabar_microns_label = gtk.Label('microns')
		self.zabar_microns_label.show()
		self.zabar_spin_button_table.attach(self.zabar_z_spin_label,0,1,0,1,xpadding = 2, ypadding = 2)
		self.zabar_spin_button_table.attach(self.zabar_microns_label,2,3,0,1,xpadding = 2, ypadding = 2)
		self.zabar_spin_button_table.show()

		#self.zabar_spin_button_table.attach(self.zabar_view_cross_section_button,0,3,1,2,xoptions = False|True, yoptions = True|True,xpadding = 2, ypadding = 2)

		self.zabar_spin_button_table.attach(self.auto_cross_section_check,0,3,2,3,xoptions = False|True, yoptions = True|True,xpadding = 2, ypadding = 2)

		self.zabar_table.attach(self.zabar_spin_button_table,0,1,1,2,xoptions = False,yoptions = False,xpadding = 2, ypadding = 2)


		#combo box to choose a ealing actuator and enter position directly


		

		#self.zabar_renumber_button_label = gtk.Label('Renumber')
		self.zabar_renumber_button = gtk.Button('Renumber')
		self.zabar_renumber_button.connect("clicked",self.renumber_mount)
		#self.zabar_renumber_button_label.show()
		self.zabar_renumber_button.show()

		self.zabar_home_all_button = gtk.Button('Home All')
		self.zabar_home_all_button.show()
		self.zabar_home_all_button.connect("clicked",self.zabar_home,0)

		self.zabar_restart_button = gtk.Button('Restart')
		self.zabar_restart_button.show()
		self.zabar_restart_button.connect("clicked",self.zabar_restart_mounts)

		self.zabar_save_position_button = gtk.Button('Save all positions to file')
		self.zabar_save_position_button.connect("clicked",self.zabar_save_pos)
		#self.save_position_label = gtk.Label('Save Position to File')
		#self.save_position_button.add(self.save_position_label)
		#self.zabar_table.attach(self.save_position_button,0,1,3,4,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)
		#self.save_position_label.show()
		self.zabar_save_position_button.show()
		
		self.zabar_recall_position_button = gtk.Button('Recall all positions from file')
		self.zabar_recall_position_button.connect("clicked",self.zabar_recall_pos)
		#self.zabar_recall_position_label = gtk.Label('Recall Position from File')
		#self.zabar_recall_position_button.add(self.recall_position_label)
		#self.zabar_table.attach(self.recall_position_button,1,2,3,4,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)
		#self.zabar_recall_position_label.show()
		self.zabar_recall_position_button.show()

		#create a table for buttons
		self.zabar_position_button_table = gtk.Table(1,6,False)
		self.zabar_position_button_table.show()
				
		self.zabar_position_button_table.attach(self.zabar_home_all_button,0,1,0,1,xpadding = 2, ypadding = 2)
		self.zabar_position_button_table.attach(self.zabar_renumber_button,1,2,0,1,xpadding = 2, ypadding = 2)
		self.zabar_position_button_table.attach(self.zabar_save_position_button,2,3,0,1,xpadding = 2, ypadding = 2)
		self.zabar_position_button_table.attach(self.zabar_recall_position_button,3,4,0,1,xpadding = 2, ypadding = 2)
		#self.zabar_position_button_table.attach(self.zabar_index_button,4,5,0,1,xpadding = 2, ypadding = 2)
		self.zabar_position_button_table.attach(self.zabar_restart_button,5,6,0,1,xpadding = 2, ypadding = 2)		

		self.zabar_table.attach(self.zabar_position_button_table,0,2,2,3,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)

		#combo_box to choose ealing mount
		self.zabar_combo_box = gtk.combo_box_new_text()
		self.zabar_combo_box.show()
        	self.zabar_combo_box.set_wrap_width(1)
       	 	for i in range(6):#self.m):
            		self.zabar_combo_box.append_text('Ealing IR%d' % (i+1))
        	self.zabar_combo_box.append_text('Aperture array')
		self.zabar_combo_box.append_text('Prism stage')
		
		self.zabar_combo_box.set_active(self.actuator-1)
        	self.zabar_combo_box.connect("changed",self.zabar_menu_changed)
		
		#create another table
		self.zabar_direct_move_table = gtk.Table(2,2,False)
		self.zabar_direct_move_table.show()

		#text box to hold position
		self.zabar_position_entry = gtk.Entry(max=6)
		self.zabar_position_entry.set_text(str(z.absolute_position(self.actuator)))
		self.zabar_position_entry.show()
		#self.zabar_position_entry_label = gtk.Label('Pos in steps')
		#self.zabar_position_entry_label.show()

		self.zabar_move_to_position_button = gtk.Button('Move to')
		self.zabar_move_to_position_button.connect("clicked",self.zabar_move_to_pos)
		self.zabar_move_to_position_button.show()

		self.zabar_refresh_position_button = gtk.Button('Refresh')
		self.zabar_refresh_position_button.connect("clicked",self.zabar_refresh_pos)
		self.zabar_refresh_position_button.show()
		
		self.zabar_direct_move_table.attach(self.zabar_combo_box,0,1,0,1,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)
		self.zabar_direct_move_table.attach(self.zabar_position_entry,0,1,1,2,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)
		self.zabar_direct_move_table.attach(self.zabar_move_to_position_button,1,2,0,1,xpadding = 2, ypadding = 2)
		self.zabar_direct_move_table.attach(self.zabar_refresh_position_button,1,2,1,2,xpadding = 2, ypadding = 2)

		self.zabar_table.attach(self.zabar_direct_move_table,1,2,1,2,xoptions = False|True,yoptions = False|True,xpadding = 2, ypadding = 2)

		#############################################

		######### Extra Windows for Plots ###########

		#create window to hold detector image, but don't show it yet
		#self.detector_image_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		#self.detector_image_window.connect("destroy",self.detector_image_window.destroy)
		#self.detector_fig = Figure(figsize=(5,4), dpi=100)
		
		#create a window to hold the intensity plot, but don't show it yet
		#self.int_image_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		#self.int_image_window.connect("destroy",self.int_image_window.destroy)
		#self.int_fig = Figure(figsize=(5,4), dpi=100)
		
		#############################################		

		if self.n != 0:
			self.refresh_positions(0)

	#################  Zabar functions ###############

	#move zabar function
	def zabar_move(self,widget,direction,actuator):
 		if actuator == 1:
			if direction == 'IN':
				z.move_relative(1,long(-1*self.zabar_z_spin_button.get_value()*10))
			elif direction == 'OUT':
				z.move_relative(1,long(self.zabar_z_spin_button.get_value()*10))
		
		elif actuator == 2:
			if direction == 'IN':
				z.move_relative(6,long(self.zabar_z_spin_button.get_value()*10))
			elif direction == 'OUT':
				z.move_relative(6,long(-1*self.zabar_z_spin_button.get_value()*10))
			
		elif actuator == 3:
			if direction == 'IN':
				z.move_relative(2,long(-1*self.zabar_z_spin_button.get_value()*10))
			elif direction == 'OUT':
				z.move_relative(2,long(self.zabar_z_spin_button.get_value()*10))
		
		elif actuator == 4:
			if direction == 'IN':
				z.move_relative(5,long(self.zabar_z_spin_button.get_value()*10))
			elif direction == 'OUT':
				z.move_relative(5,long(-1*self.zabar_z_spin_button.get_value()*10))
		
		elif actuator == 5:
			if direction == 'IN':
				z.move_relative(3,long(-1*self.zabar_z_spin_button.get_value()*10))
			elif direction == 'OUT':
				z.move_relative(3,long(self.zabar_z_spin_button.get_value()*10))
		
		elif actuator == 6:
			if direction == 'IN':
				z.move_relative(4,long(self.zabar_z_spin_button.get_value()*10))
			elif direction == 'OUT':
				z.move_relative(4,long(-1*self.zabar_z_spin_button.get_value()*10))
		
		elif actuator == 7:
			if direction == 'IN':
				z.move_relative(7,long(self.zabar_z_spin_button.get_value()*10))
			elif direction == 'OUT':
				z.move_relative(7,long(-1*self.zabar_z_spin_button.get_value()*10))

		elif actuator == 8:
			if direction == 'IN':
				z.move_relative(8,long(self.zabar_z_spin_button.get_value()*10))
			elif direction == 'OUT':
				z.move_relative(8,long(-1*self.zabar_z_spin_button.get_value()*10))

		self.zabar_refresh_pos(0)

		if (self.auto_cross_section):
			self.view_cross_section(0)
	

	#functions for saving current position to a file
	def zabar_save_pos(self,widget):
		
		self.zabar_save_filew = gtk.FileSelection('Save all positions to file')
		self.zabar_save_filew.connect("destroy",lambda w: self.zabar_save_filew.destroy())
		self.zabar_save_filew.ok_button.connect("clicked",self.zabar_file_save_action)
		self.zabar_save_filew.cancel_button.connect("clicked",lambda w: self.zabar_save_filew.destroy())
		self.zabar_save_filew.show()

	#function to actually do the filesaving
	def zabar_file_save_action(self,widget):
		z.save_position(self.zabar_save_filew.get_filename(),self.m)
		print "save info to %s" % self.zabar_save_filew.get_filename()
		self.zabar_save_filew.destroy()

	#functions for recalling position from a file
	def zabar_recall_pos(self,widget):
		
		self.zabar_recall_filew = gtk.FileSelection('Recall all positions from file')
		self.zabar_recall_filew.connect("destroy",lambda w: self.zabar_recall_filew.destroy())
		self.zabar_recall_filew.ok_button.connect("clicked",self.zabar_file_recall_action)
		self.zabar_recall_filew.cancel_button.connect("clicked",lambda w: self.zabar_recall_filew.destroy())
		self.zabar_recall_filew.show()

	#function that actually recalls the file
	def zabar_file_recall_action(self,widget):
		z.recall_position(self.zabar_recall_filew.get_filename(),self.m)
		print "recalled info from %s" % self.zabar_recall_filew.get_filename()
		self.zabar_recall_filew.destroy()		



				
	def zabar_renumber_mount(self,widget):
	
		print 'renumbering mounts '
		
		self.m = z.renumber()	
				
	def zabar_restart_mounts(self,widget):
		z.restart()
		z.renumber_mount(0)		

	def zabar_home(self,actuator):
		print actuator	
		z.home(actuator)
		self.zabar_refresh_pos(0)

	def zabar_good(self,actuator):

		good_file = open('good.eal')
		text = good_file.read()
		positions = text.split("\n")
		z.move_absolute(actuator,long(positions[actuator]))
		self.zabar_refresh_pos(0)
		
	def zabar_other(self,actuator):

		other_file = open('other.eal')
		text = good_file.read()
		positions = text.split("\n")
		z.move_absolute(actuator,long(positions[actuator]))
		self.zabar_refresh_pos(0)

	def zabar_pos(self,actuator,number):

		pos_file = open('pos%i.eal' % number)
		text = good_file.read()
		positions = text.split("\n")
		z.move_absolute(actuator,long(positions[actuator]))
		self.zabar_refresh_pos(0)

	def auto_cross_section_toggled(self,widget):
		self.auto_cross_section = self.auto_cross_section_check.get_active()
		

	#function for combo box to enter/see exact postion of ealing actuator:
	def zabar_menu_changed(self,combo_box):
	
		if combo_box.get_active() + 1 == 1:
			self.actuator = 1
		elif combo_box.get_active() + 1 == 2:
			self.actuator = 6
		elif combo_box.get_active() + 1 == 3:
			self.actuator = 2
		elif combo_box.get_active() + 1 == 4:
			self.actuator = 5
		elif combo_box.get_active() + 1 == 5:
			self.actuator = 3
		elif combo_box.get_active() + 1 == 6:
			self.actuator = 4
		else:
			self.actuator = combo_box.get_active() + 1

				
		#insert function to set text on position box
		self.zabar_refresh_pos(0)

	def zabar_move_to_pos(self,widget):
		z.move_absolute(self.actuator,long(self.zabar_position_entry.get_text()))
		
	def zabar_refresh_pos(self,widget):
		self.zabar_position_entry.set_text(str(z.absolute_position(self.actuator)))

	def main(self):
		
		gtk.main()

print __name__
if __name__ == "__main__":
	fiber = fiber()
	fiber.main()
