/* python_functions.i */
/* interface file for SWIG */

%module luminos
%{
	#include <iostream>  /* for c++ routines if necessary */
	#include <stdio.h>   /* Standard input/output definitions */
	#include <stdlib.h>  /* Standard C library routines */
	#include <unistd.h>  /* UNIX standard function definitions */
	#include <fcntl.h>   /* File control definitions */
	#include <errno.h>   /* Error number definitions */
	#include <termios.h> /* POSIX terminal control definitions for RS-232*/
	#include <string.h>  /* String function definitions */
	#include <sys/uio.h>
%}

extern struct termios old_termios;
extern int fd;

/* Functions */
extern int configure();
extern int restart();
extern int renumber();
extern int index_position(char path[20], int stages);
extern int save_position(char path[20], int stages);
extern int recall_position(char path[20], int stages);
extern int set_position( int stage, int axis, long int position);
extern int command( int device, int command, long int data);
extern int home( int stage, int axis);
extern long int absolute_position( int stage, int axis );
extern int move_absolute( int stage, int axis, long int position );
extern int move_relative( int stage, int axis, long int position );

