/************************************************************************/
/* astromod_ui.h							*/
/*                                                                      */
/* Routines for dealing with the astrometric model stuff.		*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY SERVER LIB				*/
/*		   Based on the CHARA User Interface			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar 		                        */
/* Date   : May 2006							*/
/************************************************************************/

#ifndef __ASTROMOD_UI__
#define __ASTROMOD_UI__

/* Global for the star we are currently looking at */

extern struct s_star star;
extern int reference_cart;
extern bool use_astromod_lib;

/* Prototypes */

void setup_astromod_messages(void);
int message_current_config(struct smessage *message);
int message_astromod_init(struct smessage *message);
int show_astromod_system(int argc, char **argv);
int show_astromod_scopes(int argc, char **argv);
int show_astromod_star(int argc, char **argv);
int set_no_star(int argc, char **argv);
int set_chara_star(int argc, char **argv);
int set_hd_star(int argc, char **argv);
int set_zenith(int argc, char **argv);
int set_internal(int argc, char **argv);
int set_autocoll(int argc, char **argv);
int message_set_star(struct smessage *message);
void set_star_callback(int (*callback)(void));
void unset_star_callback(void);
int message_which_star(struct smessage *message);
int message_set_reference_cart(struct smessage *message);
int message_which_reference_cart(struct smessage *message);
int message_set_use_astromod_lib(struct smessage *message);
int set_use_astromod_lib(int argc, char **argv);
char *create_astromod_data_file_name(char *dir, char *name, char *filename);
int select_reference_cart(int argc, char **argv);
int message_star_data(struct smessage *message);
int message_uv_data(struct smessage *message);

#endif
