/************************************************************************/
/* teststar.c                                                           */
/*                                                                      */
/* Test star data reading routines.					*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo		                                        */
/* Date   : March 2003                                                  */
/************************************************************************/


#include <stdio.h>
#include "chara.h"

int main(int argc, char **argv)
{
	STAR_DATA star;
	char	c;

	/* We just loop around for a very long time */

	while(1)
	{
		if (read_star_data_main(&star) != 0)
			fprintf(stderr,"Failed to get any star data.\n");

		printf("\nName\t%s\n",star.name);
		printf("Number\t%d\n",star.chara_number);
                printf("IRC\t%s\n",star.irc);
		printf("HR\t%s\n",star.hr);
		printf("HD\t%s\n",star.hd);
		printf("SAO\t%s\n",star.sao);
		printf("RA\t%s (%f)\n",star.rastr, star.ra);
		printf("DEC\t%s (%f)\n",star.decstr, star.dec);
		printf("PM_RA\t%e\n",star.pm_ra);
		printf("PM_DEC\t%e\n",star.pm_dec);
		printf("PAR\t%f\n",star.parallax);
		printf("RADVEL\t%f\n",star.radvel);
		printf("VMAG\t%f\n",star.vmag);
		printf("KMAG\t%f\n",star.kmag);
		printf("TYPE\t%s\n",star.spectype);

		c = getchar();
	}

}
