/************************************************************************/
/* functs.c								*/
/*                                                                      */
/* Discription                                   	 		*/
/*	Sets up look up table array of user callable function modules.	*/
/*	This is the file to change (along with menus.ini) when		*/
/*	installing new user callable functions.				*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

#define FUNCTS
#include "charaui.h"

int	example(int argc, char **argv);
int	question(int argc, char **argv);

int	not_implimented(int argc, char **argv)
{
	error(MESSAGE,"Function not yet implimented.");
	while (argc > 0)
	{
		error(MESSAGE,"Arugument %d = %s.",argc,argv[argc-1]);
		argc--;
	}

	if (ask_yes_no("Are you happy about that?","Well?"))
	{
		message(system_window,"Good, I'm done.");
	}
	else
	{
		message(system_window,"Too bad, I'm done.");
	}
	return NOERROR;
}

/*
 * Definition of user callable function index array.
 * Note that this array starts and ends with NULLs. This is so a
 * index of 0 gives nothing and also to help find the end of the array
 * The strings preceeding the function names are the command strings
 * that will be recognised by the command line and the menuing system.
 * All access to these functions are via this table.
 */


struct {                       
                char    *name;
                int     (*function)(int argc, char **argv);
        } functions[] = 

	{	{NULL,		NULL},
#include "std_ui_functs.h"
                {"ni",          not_implimented},
		{"example",	example},
		{"q",		question},
		{NULL,		NULL}	};
