/************************************************************************/
/* std_ui_functs.h							*/
/*                                                                      */
/* List of standard functions to be included in any functs.c file.  	*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

#ifndef __STD_FUNCTS__
#define __STD_FUNCTS__
		{"help",	ui_help},
		{"commands",	commands},
		{"auto",	ui_auto},
		{"end",		ui_end},
		{"quit",	ui_end},
		{"exit",	ui_end},
		{"sb",		background_start},
		{"stb",		background_stop},
		{"bon",		background_on},
		{"boff",	background_off},
		{"bo",		background_off},
		{"refresh",	reset_status_window_refresh},
		{"bkp",		bypass_key_poll},
		{"sleep",	go_to_sleep},
		{"shell",	ui_shell},
		{"sh",		ui_shell},
		{"asccom",	asccom},
		{"block",	call_block_sockets},
		{"unblock",	call_unblock_sockets},
		{"tss",		test_socket_scan},
		{"soccom",	soccom},
		{"ping",	ping},
		{"bm",		start_socket_command_monitor},
		{"sm",		stop_socket_command_monitor},
		{"bl",		start_socket_command_log},
		{"sl",		stop_socket_command_log},
		{"users",	machines_connected},
		{"com",		call_send_socket_command},
		{"erron",	error_messages_on},
		{"erroff",	error_messages_off},
		{"scripts",	scripts},
		{"script",	parse_script},
		{"s",		parse_script},
		{"message",	user_message},
		{"ask",		user_ask_yes_no},
		{"nothing",	do_nothing},
		{"endscript",	do_nothing},
		{"oms",		open_mirror_socket,},
		{"cms",		close_mirror_socket},
		{"status",	print_status},
#endif
