/************************************************************************/
/* local_uiclient.h							*/
/*                                                                      */
/* Standard user interface based client header file.			*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar                                         */
/* Date   : SEPTEMBER 1998                                              */
/************************************************************************/

#ifndef __LOCAL_UICLIENT__
#define __LOCAL_UICLIENT__

#include <charaui.h>
#include "../include/cliserv.h"
#include "uiclient.h"

extern int the_server;

/* uiclient.c */

int main(int argc, char **argv);
void uiclient_close_function(void);
int call_open_server_socket_by_name(int argc, char **argv);
int call_open_server_socket(int argc, char **argv);
int call_close_server_socket(int argc, char **argv);
int call_send_noop(int argc, char **argv);
int call_send_ping(int argc, char **argv);
int call_send_message_message(int argc, char **argv);
int call_send_all_noop(int argc, char **argv);
int call_send_all_ping(int argc, char **argv);

/* uichara_background.c */

void setup_background_jobs(void);
int linux_time_status(void);

#endif
