/************************************************************************/
/* uiclient_background.c						*/
/*                                                                      */
/* Background jobs for central scrutinizer.		 		*/ 
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY CLIENT INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar			                        */
/* Date   : Wed Oct 10 03:42:20 PDT 2001				*/
/************************************************************************/

#include <charaui.h>
#include "local_uiclient.h"

/************************************************************************/
/* setup_background_jobs()						*/
/*									*/
/* Guess what this does.						*/
/************************************************************************/

void setup_background_jobs(void)
{
        background_add(linux_time_status);

} /* setup_background_jobs() */

/************************************************************************/
/* linux_time_status()                                                  */
/*                                                                      */
/* Displays the linux system time in the status window.                 */
/************************************************************************/

int linux_time_status(void)
{
        time_t current_time;
        struct tm *now;

        time(&current_time);
        now = localtime(&current_time);
        wstandout(status_window);
        mvwaddstr(status_window,0,0,"Local Tm: ");
        wstandend(status_window);
        wprintw(status_window,"    %2d:%02d",
                now->tm_hour,now->tm_min);

	background_process_server_socket(the_server);

        return NOERROR;

} /* linux_time_status() */
