#!/usr/bin/local/python2.4

from random import randint  #random integer function, useful for tests
from time import sleep
import signal #for interupting mapping sequence 
from matplotlib import rcParams
import numarray as na
import pylab as pl
from pylab import cm
import common
import IRCamSocket, IRCamCommands
import time

class mircMapping:
    def __init__(self):
	self.exit_index = 0 #declare signal index globally
        self.ircs = IRCamSocket.IRCamSocket()
        self.ircc = IRCamCommands.IRCamCommands()

    def z_prism(self, stage, z_length, z_spacing, nbsteps, step, ij_range = [0,256,0,256], seconds = .5):
	
	if((z_length * 10)%1 != 0) or ( (z_spacing*10)%1 != 0):
		print 'The range and spacing of z must be divisible by 100 nm (z resolution)'
	
	zn = (z_length/z_spacing) + 1 # zn is currently float
	
	z = [None]*int(zn)
	z0 = common.lum.absolute_position(stage,1)
	z_steps = long(z_spacing*10)
	
	if ( zn % 2 == 0) or (zn % 2 == 1): #n is even or odd
		for i in range(int(zn)):
			z[i] = long(z0 - z_steps * (zn-1)/2.0 + z_steps * i)
	else:
		print 'The range divided by the spacing must be an integer value'
		return [0],[0],[0]
	
	zn = int(zn)
	n = nbsteps+1
	x = [None]*int(n)
	y = [None]*int(n)
	
	#intensities = [[intensity],[intensity],[intensity],...]
	intensities = [[[None]*2 for i in range(n)] for j in range(zn)]
	max_info = [[None]*3 for i in range(zn)]
	max_intensity_z = 0
	z_max = 0
	
	for i in range(zn):
		common.lum.move_absolute(stage,1,z[i])
		intensities[i],x,y = self.xy_square(stage, nbsteps, step, ij_range, seconds)
		max_info[i] = self.get_max(intensities[i],x,y)
		if max_info[i][2] > max_intensity_z:
			max_intensity_z = max_info[i][2]
			max_index = i
		
	common.lum.move_absolute(stage,1,z0)
	print 'Maximum intensity at z = ',z[max_index]
	print '                     x = ',max_info[max_index][0]
	print '                     y = ',max_info[max_index][1]
	print 'intensity = ',max_info[max_index][2]
	
	return [intensities, x, y, z] 
	
    def xy_total(self, stage, step, range_i = [0,256], range_j = [0,256], seconds = .5):
	if ((spacing * 1000) % 4 !=0):
		print 'The spacing must be divisible by 4 nm (xy resolution)'
		return 0
	
	common.lum.move_absolute(stage, 2, 62500)
	common.lum.move_absolute(stage, 3, 62500)
	return self.xy_square(stage, 500, step, ij_range, seconds)
	 

    def xy_square(self, stage, nbsteps, stepsz, ij_range= [0,256,0,256], disp_img = 1):
	
	#take dummy exposure to kill buffer
	#dat.Exposure()
	#sleep(0.001*dat.exptime+0.040)

	rcParams['interactive'] = True
        nbsteps = int(nbsteps)
	if ((stepsz * 1000) % 4 != 0):
            print 'The range and spacing must be divisible by 4 nm (xy resolution)'
            return 0,0,0
        
	x0 = common.lum.absolute_position(stage,2)
	y0 = common.lum.absolute_position(stage,3)
	steps = long(stepsz * 250)

        x_tmp = long(x0 - steps * (nbsteps-1)/2.0) + steps * na.array(range(nbsteps), type = na.Int32)
        y_tmp = long(y0 - steps * (nbsteps-1)/2.0) + steps * na.array(range(nbsteps), type = na.Int32)
        
        x = na.compress((x_tmp > 0) & (x_tmp < 128000), x_tmp)
        y = na.compress((y_tmp > 0) & (y_tmp < 128000), y_tmp)

        x_microns_tmp = long(- stepsz * (nbsteps-1)/2.0) + stepsz * na.array(range(nbsteps), type = na.Int32)
        y_microns_tmp = long(- stepsz * (nbsteps-1)/2.0) + stepsz * na.array(range(nbsteps), type = na.Int32)
	
        x_microns = na.compress((x_tmp > 0) & (x_tmp < 128000), x_microns_tmp)
        y_microns = na.compress((y_tmp > 0) & (y_tmp < 128000), y_microns_tmp)

        common.x_microns = x_microns
        common.y_microns = y_microns
        
	intensity = na.zeros((len(y),len(x)))
	
	#initiate window for plotting
	if (disp_img):
            #use figure 3 active figure
            pl.figure(3)
            pl.clf()
            #set axes
            img_extent = x[0]-0.5*steps, x[-1] + 0.5*steps, y[0] - 0.5*steps, y[-1] + 0.5*steps
            img_extent_microns = x_microns[0]-0.5*stepsz, x_microns[-1]+0.5*stepsz, \
                                 y_microns[0]-0.5*stepsz, y_microns[-1]+0.5*stepsz
            common.img_extent_microns = img_extent_microns
            pl.title('Image of Intensity vs. Position, Current Map')
            pl.xlabel('X in microns')
            pl.ylabel('Y in microns')
            pl.ylabel('Y in microns') #advance the frame
		
	#set the signal handler
	signal.signal(signal.SIGTSTP,self.xy_interupt)
	print 'CTRL-Z to stop mapping after current row'
	global exit_index
	exit_index = 0 #becomes 1 (true) when signal sent
	
	#nested for loops activate mappingxplt
	#first for loop gives y coordinate
	#second for loop gives x coordinate	
	
	for i in range(len(y)):
            if exit_index : break
            common.lum.move_absolute( stage , 3, y[i] )
            for j in range(len(x)):
                if exit_index : break
                #if statement decides which direction to map across x
                if i % 2 == 0:
                    common.lum.move_absolute( stage, 2 , x[j] )
                    #sleep(seconds)
                    #Read intensity into 2-D list 
                    intensity[i][j] = self.get_intensity(ij_range)
                else:
                    common.lum.move_absolute( stage, 2 , x[-1 - j] );
                    #sleep(seconds)
                    #Read intensity into 2-D list 
                    intensity[i][-1 - j] = self.get_intensity(ij_range)
                
		if disp_img:
                    pl.imshow(intensity,origin = 'lower',cmap =cm.cool,\
                              vmin = intensity[:i+1][:j+1].min(), vmax = intensity[:i+1][:j+1].max(), \
                              extent = img_extent_microns,interpolation='nearest')
                    pl.ylabel('Y in microns')                    
				
	#reset signal to default
	signal.signal(signal.SIGTSTP, signal.SIG_DFL)
			
	#move back to original location	
	common.lum.move_absolute(stage,2,x0)
	common.lum.move_absolute(stage,3,y0)

	#close()
	
	#rcParams['interactive'] = False
		
	return intensity,na.array(x),na.array(y),False



    def xy_interupt(self, signum,frame):
	print 'Interupt signal sent, mapping will end after this row...'
	global exit_index
	exit_index = 1
	#sleep(1)
	return 

    def get_max(self, intensity,x,y):
	
	maximum = 0
	x_max_index = 0
	y_max_index = 0
	
	ny = len(y)
	nx = len(x)
	
	for i in range(ny):
            for j in range(nx):
                if intensity[i][j] > maximum:
                    maximum = intensity[i][j]
                    x_max_index = j
                    y_max_index = i
	
	#move_absolute(stage,2,x[x_max_index])
	#move_absolute(stage,3,y[y_max_index])
	
	#del(dat)
		
	return [x[x_max_index],y[y_max_index],intensity[y_max_index][x_max_index]]
	
    def get_intensity_random(self):
	return randint(0,100)

    # get_intensity takes the range of pixels to be sampled and
    # returns the total intensity accross those pixels

    def get_intensity(self, ij_range = [0,256,0,256]):
        self.getNextFrame()
        total_intensity = common.dataArray[ij_range[0]:ij_range[1], ij_range[2]:ij_range[3]].sum()
## 	for i in range(ij_range[0], ij_range[1]):
## 		for j in range(ij_range[2], ij_range[3]):
## 			total_intensity += dat.img[i][j]
	return total_intensity

    def xy_surf(self, intensity,x,y):
	
	start_x = x[0]
	start_y = y[0]
	
	x_microns = [None] * len(x)
	y_microns = [None] * len(y)
	
	for i in range(len(x)):
		x_microns[i] = (x[i] - start_x) / 250.
	for i in range(len(y)):
		y_microns[i] = (y[i] - start_y) / 250.	
		
	gplt.surf(x_microns,y_microns,intensity)
	gplt.title('Intensity on camera vs. Luminos stage XY position')
	gplt.xtitle('X position in microns')
	gplt.ytitle('Y position in microns')
	gplt.ztitle('Intensity')
	gplt.hidden("remove")
	return

    def getNextFrame(self):
        #variable that is use to check if the available frame is a new frame
        common.coaddCount = self.ircc.coaddCount()
        coadd = common.coaddCount
        cnt = 0
        while coadd < common.coaddCount+2:
            coadd = self.ircc.coaddCount()
            cnt += 1
            time.sleep(.2)
        # a new frame is available, read the new frame
        self.ircs.readFrame()
        common.coaddCount = coadd
        if common.numberOfCumulatedImages>1:
            cnt = 0
            tmp = common.dataArray
            for i in range(common.numberOfCumulatedImages-1):
                while coadd == common.coaddCount:
                    coadd = self.ircc.coaddCount()
                    cnt += 1
                    time.sleep(.5)
                    # a new frame is available, read the new frame
                self.ircs.readFrame()
                common.coaddCount = coadd
                tmp += common.dataArray
            common.dataArray = tmp/common.numberOfCumulatedImages
            

    def getFrame(self):
        #variable that is use to check if the available frame is a new frame
        coadd = common.coaddCount
        cnt = 0
        #img = na.zeros((common.numberOfCumulatedImages, common.rows, common.cols), type = na.Float32)
        tmp = na.zeros((common.rows, common.cols), type = na.Float32)
        for i in range(common.numberOfCumulatedImages):
            while coadd == common.coaddCount:
                coadd = self.ircc.coaddCount()
                cnt += 1
                time.sleep(.5)
                # a new frame is available, read the new frame
            self.ircs.readFrame()
            common.coaddCount = coadd
            tmp += common.dataArray
            #img[i, :, :] = common.dataArray
        common.dataArray = tmp/common.numberOfCumulatedImages
