/************************************************************************/
/* astrogtk.h								*/
/*                                                                      */
/* Header file for astrogtk library.					*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar						*/
/* Date   : May 2006                                               	*/      
/************************************************************************/

#ifndef __ASTRO_CLISERV__
#define __ASTRO_CLISERV__

#include <cliserv.h>
#include <chara.h>

/* Globals */

struct astro_control_window_data {char *name; int server;};
struct astro_init_window_data {char *name; int server; char get_config;};

extern int chara_number[MAX_SERVERS]; /* Chara number of current star */
extern int reference_cart[MAX_SERVERS];   /* Which reference cart */
extern int last_reference_cart;
extern struct s_astromod_init beam_config;

/* Prototypes */

/* astro_control_wondow.c */

GtkWidget* create_astrogtk_control_window (GtkButton *button, gpointer *data);
void astrogtk_control_ok_callback(GtkButton *button, gpointer user_data);
void astrogtk_setstar_callback(GtkButton *button, gpointer user_data);
void astrogtk_chara_callback(GtkButton *button, gpointer user_data);
void astrogtk_hd_callback(GtkButton *button, gpointer user_data);
bool astrogtk_get_current_star(int server);

/* astro_init_wondow.c */

GtkWidget* create_astrogtk_init_window (GtkButton *thebutton, gpointer *data);
void astrogtk_init_ok_callback(GtkButton *button, gpointer doit);
bool astrogtk_get_current_config(int server);
bool astrogtk_get_current_reference_cart(int server);
void set_config_callback(int (*callback)(void));
void unset_config_callback(void);

/* astro_messages.c */

int setup_astro_messages(int server);
int message_astromod_init(int server, struct smessage *mess);
int message_astromod_set_star(int server, struct smessage *mess);
int message_astromod_set_reference_cart(int server, struct smessage *mess);

#endif
