/************************************************************************/
/* baytech.h								*/
/*                                                                      */
/* Header file for Baytech control routines.				*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar et al.                                  */
/* Date   : Feb 1999                                                    */
/************************************************************************/

#ifndef __BAYTECH__
#define __BAYTECH__

#include <charaui.h>

#define BAYTECH_TIME_OUT 2

/* baytech_control */

int call_open_baytech_rpc_port(int argc, char **argv);
int call_reopen_baytech_rpc_port(int argc, char **argv);
int call_close_baytech_rpc_port(int argc, char **argv);
int call_baytech_rpc_on(int argc, char **argv);
int call_baytech_rpc_off(int argc, char **argv);
int call_baytech_rpc_all_on(int argc, char **argv);
int call_baytech_rpc_all_off(int argc, char **argv);
unsigned char	get_baytech_rpc_get_status(void);
int call_open_baytech_m4_port(int argc, char **argv);
int call_close_baytech_m4_port(int argc, char **argv);
int call_baytech_m4_relay_status(int argc, char **argv);
int call_baytech_m4_relay_energize(int argc, char **argv);
int call_baytech_m4_relay_de_energize(int argc, char **argv);
int call_baytech_m4_set_dac(int argc, char **argv);
int call_baytech_m4_dac_array(int argc, char **argv);
int call_baytech_m4_adc_status(int argc, char **argv);

/* baytech_rpc.c */

struct sserial open_baytech_rpc_port(char *port_name);
unsigned char  reopen_baytech_rpc_port(struct sserial *port);
unsigned char baytech_rpc_get_status(struct sserial port);
unsigned char baytech_rpc_on(struct sserial port, int channel);
unsigned char baytech_rpc_off(struct sserial port, int channel);
unsigned char baytech_rpc_all_on(struct sserial port);
unsigned char baytech_rpc_all_off(struct sserial port);

/* baytech_m4.c */

struct sserial open_baytech_m4_port(char *port_name);
unsigned char baytech_m4_relay_status(struct sserial port);
int baytech_m4_relay_energize(struct sserial port, int channel);
int baytech_m4_relay_de_energize(struct sserial port, int channel);
int baytech_m4_set_dac(struct sserial port, int channel, int value);
int baytech_m4_dac_array(struct sserial port, int channel,
			int values[], int n);
float *baytech_m4_adc_status(struct sserial port);
void baytech_m4_clear(struct sserial port);

#endif
