#include <stdio.h>
#include "matrox_meteor.h"
#include <nsimpleX.h>
#include <string.h>
#include <sys/mman.h>
#include <ioctl_meteor.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <time.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/types.h>
#include <asm/errno.h>
#include <errno.h>

int errno;

int main(int argc, char **argv)
{
	int  c;
	XImage *theImage;
	unsigned char *picture,*p8;
	unsigned short int *p16;
	unsigned int *p32;
	int size;
	unsigned char  *mbuf;
	int 	i,j,color;
	int	brightness;
	int 	contrast;
	int	chan;
	int	col,row;
	time_t start_time;
	int	frames;
	Window theWindow;
	unsigned char *buffer;
	int    x,y,max;
	time_t stop_time;
	float	time_period;

	if (argc < 6)
	{
		fprintf(stderr,
		"usage: %s chan col row contrast brightness\n",argv[0]);
		exit(-2);
	}
	sscanf(argv[1],"%d",&chan);
	sscanf(argv[2],"%d",&col);
	sscanf(argv[3],"%d",&row);
	sscanf(argv[4],"%d",&contrast);
	sscanf(argv[5],"%d",&brightness);
	size = col*row;
	if ((buffer = malloc(size)) == NULL)
	{
		fprintf(stderr,"Ran out of memory\n");
		exit(3);
	}

	if ((c = open_meteor_continuous(NULL, col, row)) != 0)
	{
		fprintf(stderr,"Failed opening device: %d %s\n",c,
			strerror(errno));
		exit(-1);
	}

	if ((c = set_meteor_chan(chan)) != 0)
	{
		fprintf(stderr,"Failed setting channel: %d %s\n",c,
			strerror(errno));
		exit(-1);
	}
	
	if ((c = set_meteor_brightness(brightness)) != 0)
	{
		fprintf(stderr,"Failed setting brightness: %d %s\n",c,
			strerror(errno));
		exit(-1);
	}
	
	if ((c = set_meteor_contrast(contrast)) != 0)
	{
		fprintf(stderr,"Failed setting contrast: %d %s\n",c,
			strerror(errno));
		exit(-1);
	}
	
	initX(NULL);
	theWindow = openWindow("CONT", 5, 5, col, row);

	/* Make sure stdin is non-blocking */

	if (fcntl(fileno(stdin), F_SETFL, O_NONBLOCK) == -1)
	{
		fprintf(stderr,"failed to set non-blocking stdin.\n");
		exit(-5);
	}

	frames = 0;
	time(&start_time);
	while(1)
	{
		/* Go and get a picture */

		max = meteor_continuous_get_frame(buffer, &x, &y);

		/* Allocate the memory */

		if ((picture = malloc(size*theBitmapPad)) == NULL)
		{
			fprintf(stderr,"Ran out of memory\n");
			exit(3);
		}

		p8 = picture;
		p16 = (unsigned short int *) picture;
		p32 = (unsigned int *) picture;
		mbuf = buffer;
		for(j=0; j< row; j++)
		for(i=0; i< col; i++)
		{
			if (i == x || j == y)
			{
				color = NUM_COLORS-1;
			}
			else
			{
				color = (*mbuf)/2;

				if (color < 0) 
					color = 0;
				else if (color > NUM_COLORS-1)
					color = NUM_COLORS-1;
			}

			switch(theDepthBytes)
			{
				case 1: *p8++ = GreyScale[color];
					break;
				case 2: *p16++ = GreyScale[color];
					break;
				default: *p32++ = GreyScale[color];
					break;
			}
			mbuf++;
		}
		
		theImage = XCreateImage(theDisplay,theVisual,theDepth,ZPixmap,0,
                        (char *)picture,col,row, theBitmapPad ,0);
		XPutImage(theDisplay,theWindow,theGC,theImage,0,0,0,0,col,row);
		XMapWindow(theDisplay, theWindow);
		XFlush(theDisplay);
		XDestroyImage(theImage);
		
		frames++;

		if (getchar() == 'q') break;
	}
	close_meteor_continuous();

	time(&stop_time);

	time_period = stop_time - start_time;
	printf("Frames displayed per second = %f\n",(float)frames/time_period);
	printf("max = %d  at (%d,%d)\n",max,x,y);

	exit(0);
}
